
 #   aaaaaaaaaaaaa   aaaaa     aaaa aaaaaaaaaaaaaaaaa
 # H3sm 1.5.shasm		 Feb/Mar 2001
 # shasm  assembly language subroutine-threaded version
 # comments with # in the first column are appended to glossary
 # GNU x86 gas, GNU m4

define(STACKSIZE, 0X2000)
define(cell, 4)

.text

 #endianism stuff, change 1 2 3 4 to 4 3 2 1 for big-endian,
 #after	Michael Somos. In re 64-bit etc. I'm open to advice.
 #This is leftovers from the C version, but it may come in handy.

define(ENDIANCELL, 
`.byte $1, $2, $3, $4'
)

define(SPEW,
	`call one
	call printhex'	)

 # H3sm-specific stuff. Register aliases are added to the shasm parser.

define(BP, %ebp)

define(copyb, movb)
define(quadalign, `.align 4,0')
define(copydual, movw)
define(ORb, orb)
define(BL, %bl)

define(syscall,
	`int $`'128'				# Linux, int 0x80
)

define(SUSPECT)

define(Return,
ret ;
)

define(HANDOFF,
	pushf
	   pusha
	      call schedule	# exuent to host
	   popa
	popf
)


        .align 16
.globl main
        .type    main,@function
main:
#Barbara


copy $ttyname to B
copy $5 to A
copy $2 to C
copy $0 to D
int $128


copy $ttyname to B
copy $5 to A
copy $2 to C
copy $0 to D
int $128


copy $ttyname to B
copy $5 to A
copy $2 to C
copy $0 to D
int $128


copy $0 to A		# new world. clean slate.
copy $0 to B
copy $0 to C
copy $0 to D
copy $0 to %ebp
copy $0 to %esi
copy $0 to %edi


copy $4 to Size

copy $ps to PSI

copy $ds to DSI

copy $0xc001c001 to (PSI)

copy $initial_LATEST to A

copy A to latest

copy $bufferlabel to A

copy A to thisl
copy A to epal

                        # pass argv* to interpreter
copy (argc) to A
increment A
upshift A
upshift A
add (argv) to A
copy (A) to A
copy A to epal
copy A to envp

copy argv to A
copy (A) to A
copy A to thisl

                                # open "stdaux" to tty
pusha
copy $ttyname to B
copy $5 to A
copy $0 to C
copy $0 to D
int $128
popa




increasing
reepeeet: 
call  zygote
jump reepeeet			#   data byte stack, byte access array
				#   byte-only data stack, 
				#            everything gets
				#  converted to bytes internally in
				#  this implementation.
				#   the pointer stack itself

 #  `   dyte arithmatic spaces'

ps:
.org . + 256

ds: 
.org . + STACKSIZE


BYTES:
.org . + 256

modulo:
.org . + 256

accum:
.org . + 256

head:
.org . + 256

ttyname:
.ascii "/dev/tty"

.org . + 16
			#digits up to base 16. I prefer lowercase.
			#Also, e.g. FF is then a WORD only. Handy.

digitOut: 
.ascii  "0123456789abcdef"

			#   to save syscalling write on each digit
numberString: 
.org . + 512




 #AARDVARK!  AARDVARK!  aardvark exists just to be un-'-able due to   0 cnt
 #byte, ie. no name, and/or code field, and to be the starting point for#the
 #dictionary linking. Handrolled ( non-macro )  empty neck.
 #The way to terminate a namespace traversal is when an HNC has a 0 length
 #byte. :NO(NAME isn't a problem because that's not a linked thing at all,
 #is it?

        1:
        0:
        .byte 0
        .byte 0
        .byte 0
        .byte 0
        .ascii "aardvark"
        .align 4, 0
        .int  0
        .int  0
aardvark:



 # m4m4m4m4m4m4m4m4m4m4m4 m4 macro to do dictionary things as assembly
 #directives.  Doing this as macros in cpp doesn't appear to be possible
 #due
 #to `"' issues. The semantic overhead of an m4 pass is well paid for by
 #the
 #strikingly Forthish simplicity of doing what we actually want to do
 #directly.
 #
 #There's some running m4 logic to toggle the labels produced in each
 #header
 #due to some rigidity of gas.  Thanks to Andi Kleen for the general idea.
 #He further suggests using a counter instead of a mere toggle, which may
 #come into play with multiple vocabularies, I guess. I'm still open to
 #simpler methods. I'm not dead sure gas can't do this on it's own, even.
 #

define(`ALTLABEL', 0:)
define(`ALTREF', 1b )

 # these need to take a C/asm name and a H3m name.
 #        These could be hand-adjusted for CELL other than 4

define(ATOM_,
`ifelse(ALTLABEL,0:, `define(`ALTLABEL', 1:)  define(`ALTREF', 0b)',
                    `define(`ALTLABEL', 0:)  define(`ALTREF', 1b)' )'
	.align 4
        `ALTLABEL'
        .byte   `len($2)'
        .byte   0
        .byte   0x80
        .byte   0
        .ascii  "`$2'"
`        .align  4, 0'
        .int    `ALTREF'
`        .equ    `$1'CFA, .'
``$1:''					)


define(HATOM_,
`ifelse(ALTLABEL,0:, `define(`ALTLABEL', 1:)  define(`ALTREF', 0b)',
                    `define(`ALTLABEL', 0:)  define(`ALTREF', 1b)' )'
	.align 4
        `ALTLABEL'
        .byte   `len($2)'
        .byte   0
        .byte   0x80
        .byte   1
        .ascii  "`$2'"
     `   .align  4, 0'
        .int    `ALTREF'
`        .equ    `$1'CFA, .'
$1:					)


define(THREAD_,
`ifelse(ALTLABEL, 0:, `define(`ALTLABEL', 1:) define(`ALTREF', 0b)' ,
                        `define(`ALTLABEL', 0:) define(`ALTREF', 1b)' )'
	.align 4
        `ALTLABEL'
        .byte `len($2)'
        .byte 0
        .byte 0
        .byte 0
        .ascii "`$2'"
  `      .align 4, 0'
        .int  `ALTREF'
`        .equ    `$1'CFA, .'
$1:					)

 # The m4 pass is first. In most of these macros we compute the length of
 #the word name at m4-time, which means we need another macro if we need
 #escapes for .ascii's in asm, which look like name chars to m4. This is
 #the
 #case for H3m names containing " or \

define(THREADING_NAMELEN,
`ifelse(ALTLABEL, 0:, `define(`ALTLABEL', 1:) define(`ALTREF', 0b)' ,
                        `define(`ALTLABEL', 0:) define(`ALTREF', 1b)' )'
	.align 4
        `ALTLABEL'
        .byte $3
        .byte 1
        .byte 0
        .byte 0
        .ascii "`$2'"
   `     .align 4, 0'
        .int  `ALTREF'
 `       .equ    `$1'CFA, .'
$1:				)

 # this is a thread header vith a non-user bit for leaving
 #interpreter-only  words and such out of "words", i.e. mildly hidden.

define(NON_USER,
`ifelse(ALTLABEL, 0:, `define(`ALTLABEL', 1:) define(`ALTREF', 0b)' ,
                        `define(`ALTLABEL', 0:) define(`ALTREF', 1b)' )'
	.align 4
        `ALTLABEL'
        .byte `len($2)'
        .byte 0
        .byte 0
        .byte 1
        .ascii "`$2'"
 `       .align 4, 0'
        .int  `ALTREF'
`        .equ    `$1'CFA, .'
$1:				)

define(THREADING,
`ifelse(ALTLABEL, 0:, `define(`ALTLABEL', 1:) define(`ALTREF', 0b)' ,
                        `define(`ALTLABEL', 0:) define(`ALTREF', 1b)' )'
	.align 4
        `ALTLABEL'
        .byte `len($2)'
        .byte 1
        .byte 0
        .byte 0
        .ascii "`$2'"
`        .align 4, 0'
        .int  `ALTREF'
 `       .equ    `$1'CFA, .'
$1:
				)

#  	ATOMS...


 			#ppppppppppppppppppppppprimitives
			#==================================
#   address		(P --- ptr ) ends a thread's action.	KG
ATOM_(address,address)                #      (P --- ptr )
        add $4 to  PSI 
	pop (PSI)		# extra Return in effect.
		Return		# will return to caller's caller,
				#	ending the thread.


		#==================================
#   AND		( pytea pyteb ---  aANDb ) the bitwise Boolean, pytewise
ATOM_(And,AND)
	setsource
	DROP
	setdest
	askcells
	ifnonzero 			noncell_AND
	   copy (source) to  A
	   AND A to (dest)
		Return
noncell_AND: 
		add Size to source
		add Size to dest
		askodd
		ifnocarry			ANDnotodd
			decrement dest
			decrement source
			copyb (source) to %al	
			andb %al to (dest)
ANDnotodd:
		askextradual
		ifnocarry				ANDquads
			decrement dest
			decrement dest
			decrement source
			decrement source
			copydual (source) to %ax	
			andw %ax to (dest)
ANDquads:
		testAND $-4 to Size
		ifzero 						ANDbail
ANDquadsloop:
		sub $4 to dest
		sub $4 to source
			copy (source) to A
			and A to (dest)
		testsubtract DSI to dest
		ifnonzero			ANDquadsloop
ANDbail:
	Return


			#==================================
#   aint		( flagp --- !flagp ) casual NOT, bitwise on lsB.
ATOM_(aint,aint)
xorb  $255 to  (DSI)
	Return


			#==================================
#   align		(P  a  --- a_rounded_up_to_CELLSIZE
ATOM_(align,align)
	add $3 to (PSI)
	AND $0xfffffffc to (PSI)
		Return


			#==================================
#   bump		( ---  old_pyte ) undrop. Only useful in threads.
ATOM_(bump,bump)
	BUMP
		Return


			#====================================
 #   BYTES		sizeof(int) -> Size
 # ATOM_(bytes,bytes)
 #	movb  $1 to Size
 #		Return


			#===================================
#   bytes		bump  1->Size  drop
ATOM_(bytes,bytes)
	BUMP
	movb $1 to Size
	DROP
		Return


			#====================================
#   cells		bump  sizeof(int)->Size  drop
ATOM_(cells,cells)
	BUMP
	movb $4 to Size
	DROP
		Return


			#====================================
 #   cells		sizeof(int) -> Size
 # ATOM_(cells,cells)
 #	movb  $4 to  Size
 #		Return
 #

			#==================================
#   drop		( pyte --- )
ATOM_(drop,drop)
	DROP
		Return


			#==================================
#   dup		( pytea ||| ---	 pytea )  i.e.	  ( a --- a a 
ATOM_(dup,dup)
	setsource
	BUMP
	setdest
	askcells
	ifnonzero			noncell_dup
	   copy (source) to  A
	   copy A to  (dest)
		Return
noncell_dup: 
		add Size to source
		add Size to dest
		askodd
		ifnocarry		dupnotodd
			decrement dest
			decrement source
			copyb (source) to %al	
			copyb %al to (dest)
dupnotodd:
		askextradual
		ifnocarry			dupquads
			decrement dest
			decrement dest
			decrement source
			decrement source
			copydual (source) to %ax	
			copy %ax to (dest)
dupquads:
		testAND $-4 to Size	# if Size has some cells
		ifzero 					dupbail
dupquadsloop:
		sub $4 to dest
		sub $4 to source
			copy (source) to A
			copy A to (dest)
		testsubtract DSI to dest
		ifnonzero		dupquadsloop
dupbail:
	Return


			#==================================
#   dshift	NU	( shiftee amount --- shifted ) down-signif.bitshift
ATOM_(dshift,dshift)

 push Size
 copyb (DSI)  to %cl			# the shift amount
 copy $0 to source			# initialize "low"
dshloop:
	sub $4 to DSI
	copy (DSI) to A
	shrd source to A
	copy A to source 
	sub $4 to Size
	ifnonzero		dshmo
		copy A to (DSI)
	    pop Size
	Return
dshmo:
	testAND $-4 to Size
	ifzero				dshodd
		copy A to (DSI)
		jump 					dshloop
dshodd:
	testAND $2 to Size
	ifzero					nodualdsh
		movw %ax to (DSI)
		sub $2 to DSI
nodualdsh:
	testAND $1 to Size
	ifzero				exuentdsh
		movb %al to (DSI)
		sub $1 to DSI
exuentdsh:
		pop Size
	Return


			#==================================
#   double	NU	up-roll Size by 1, > 256 wraps
ATOM_(double,double)
	upshift  %dl
	ifnonzero	doubledone
	movb $4 to Size
doubledone:
	Return


			#==================================
#   doHNC		(P @HNC	 --- )   execute word given @HNC
ATOM_(doHNC,doHNC)
	copy	(PSI) 	to 	source
	PDROP
	copy	(source) 	to A
	add	$11 to  A
	and 	$0xfc	to A
	add	A	to 	source
		jmp source


			#==================================
#   emit		(pyte --- )  ascii print lsB. Just get it working
ATOM_(emit,emit)
pusha
copy (DSI) to A
copy A to numberString 
copy $numberString to C			# DSI is B
copy $4 to A			# write, Linux syscall 4
copy $1 to B			# FD
copy $1 to  D			# length
int $128
popa				# ignoring return value in A
DROP
	Return


			#==================================
#   false		( --- 0flagpyte )  fast false lsB
ATOM_(false,false)
	BUMP
	copyb $0 to (SI)
		Return


			#==================================
#   @		(P ptr ||| --- ) ( --- pyte ) fetch pyte at ptr at Size
ATOM_(fetch,@)
	BUMP
	setdest
	mov (PSI) to source
	askcells
	ifnonzero 		noncell_fetch
	      copy (source) to A
	      copy A to (dest)
			Return
noncell_fetch: 
		add Size to dest
		add Size to source
		askodd
		ifnocarry		fetchdual
			decrement dest
			decrement source
			movb (source) to %al
			copy %al to (dest)
fetchdual:
		askextradual
		ifnocarry		fetchquads
			decrement dest
			decrement dest
			decrement source
			decrement source
			movw (source) to %ax
			movw %ax to (dest)
fetchquads:
		testAND $-4 to Size
		ifzero 				fetchbail
fetchquadsloop:
		sub $4 to dest
		sub $4 to source
			mov (source) to A
			mov A to (dest)
		testsubtract DSI to dest
		ifnonzero			fetchquadsloop
fetchbail:
	Return


		#==================================
#   @+		(P ptr --- ptr+Size ) ( --- pyte ) 
ATOM_(fetchplus,@+)
	BUMP
	setdest
	mov (PSI) to source
	add Size to (PSI)
	askcells
	ifnonzero 		noncell_fetchplus
	      copy (source) to A
	      copy A to (dest)
				Return
noncell_fetchplus: 
		add Size to dest
		add Size to source
		askodd
		ifnocarry		fetchplusdual
			decrement dest
			decrement source
			movb (source) to %al
			copy %al to (dest)
fetchplusdual:
		askextradual
		ifnocarry		fetchplusquads
			decrement dest
			decrement dest
			decrement source
			decrement source
			movw (source) to %ax
			movw %ax to (dest)
fetchplusquads:
		testAND $-4 to Size
		ifzero 				fetchplusbail
fetchplusquadsloop:
		sub $4 to dest
		sub $4 to source
			mov (source) to A
			mov A to (dest)
		testsubtract DSI to dest
		ifnonzero			fetchplusquadsloop
fetchplusbail:
	Return


			 #==================================
#   flag		( pyte --- flagpyte ) if pyte <>0 lsB of pyte <> 0
ATOM_(flag,flag)
	setsource
	setdest
	askcells
	ifnonzero 		flagnoncell
	   add $0 to (DSI)
		ifnonzero 		cellflagtrue
			Return
cellflagtrue:	
	movb $255 to (DSI)
		Return
flagnoncell:
push Size
copy DSI to source
add Size to source
flagperbyte:
		decrement source
		movb (source) to A
		addb $0 to A
		ifzero 			flagarewedone
		movb $255 to (DSI)
		pop Size
			Return
flagarewedone:
decrement Size
ifnonzero			flagperbyte
	pop Size
		Return


			#==================================
#   getSize		(P --- Size)
ATOM_(getSize,getSize)
	PBUMP
	copy Size  to  (PSI)
		Return


			#==================================
#   gap		(P a b ||| ) ( --- a-b ) assumes Size=4		KG
ATOM_(gap,gap)
	BUMP
	setdest
	copy -4(PSI) to A
	subtract  (PSI) with A
	copy A to (DSI)
		Return


			#==================================
#   halve	NU	halve Size. 0 forced to cellsize
ATOM_(halve,halve)
	downshift  %dl	
	ifzero		halve0iscells
		Return
halve0iscells:
		movb $4 to Size	
			Return


			#==================================
#   H3sm	U	no-op. No action besides incremnt VM instr pointer
ATOM_(Hm,Hm)
	Return


			#==================================
#   ?()=		(P &a &b ||| ) ( ---  flag ) comp pointed-to pytes
ATOM_(ifcontentsequal,``?()''=)

  	copy (PSI) to source
	PDROP
	copy (PSI) to dest
	BUMP
	PBUMP
	askcells
	ifnonzero 		noncell_ifcontentsequal
		copy (dest) to A
		testsubtract A with (source)
	     	ifnonzero		done_ifcontentsequal_false
		movb $255 to   (DSI)
	     		Return
noncell_ifcontentsequal:
		add Size to source
		add Size to dest
		askodd
		ifnocarry		ifcontentsequalnotodd
			decrement dest
			decrement source
			copyb (source) to %al	
			cmpb  %al to (dest)
			ifnonzero	done_ifcontentsequal_false
ifcontentsequalnotodd:
		askextradual
		ifnocarry			ifcontentsequalquads
			decrement dest
			decrement dest
			decrement source
			decrement source
			copydual (source) to %ax	
			cmpw %ax to (dest)
			ifnonzero	done_ifcontentsequal_false
ifcontentsequalquads:
		testAND $-4 to Size
		ifzero				done_ifcontentsequal_true
ifcontentsequalquadsloop:
		sub $4 to dest
		sub $4 to source
			copy (source) to A
			testsubtract  A to (dest)
			ifnonzero	done_ifcontentsequal_false
		testsubtract DSI to dest
		ifnonzero			ifcontentsequalquadsloop
done_ifcontentsequal_true: 
	movb $255 to   (DSI)
		Return

done_ifcontentsequal_false: 
	movb  $0 to  (DSI)
		Return


		#==================================
#   ?=		( a b --- flagpyte ) 0xXX..ff (true) if a = b
ATOM_(ifequal,?=)
	setsource
	DROP
	setdest
	askcells
	ifnonzero		noncell_askequal
		copy (dest) to A
		testsubtract A with (source)
	     	ifnonzero		done_askequal_false
		jump			done_askequal_true
noncell_askequal: 
		add Size to source
		add Size to dest
		askodd
		ifnocarry			askequalnotodd
			decrement dest
			decrement source
			movb (source) to %al	
			cmpb %al to (dest)
			ifnonzero		done_askequal_false
askequalnotodd:
		askextradual
		ifnocarry			askequalquads
			decrement dest
			decrement dest
			decrement source
			decrement source
			copydual (source) to %ax	
			cmpw %ax to (dest)
			ifnonzero		done_askequal_false
askequalquads:
		testAND $-4 to Size
		ifzero					done_askequal_true
askequalquadsloop:
		sub $4 to dest
		sub $4 to source
			copy (source) to A
			cmp A to (dest)
			ifnonzero		done_askequal_false
		testsubtract DSI to dest
		ifnonzero			askequalquadsloop
done_askequal_true:
		movb $255 to (DSI)
			Return
done_askequal_false:
		movb $0 to (DSI)
			Return


		#==================================
#   ?positive	( a  --- flagpyte )  0 considered positive

ATOM_(ifpositive,?positive)
	setdest
	add Size to dest
	decrement dest
	testANDb $128 to  (dest)
	ifnonzero		 		nonpos
		mov $255 to A
		mov A to (DSI)
			Return
nonpos:
		movb $0 to A
		mov A to (DSI)
			Return


			#==================================
#   literal		( --- pyte ) literal pyte
ATOM_(literal,literal)
	pull source
	xor A to A
	movb (source) to %al
	increment source
	add source to A
	push A
	BUMP
	setdest
	askcells
	ifnonzero 		noncell_lit
	   copy (source) to  A
	   copy A to	(dest)
		Return
noncell_lit:
		add Size to source
		add Size to dest
		askodd
		ifnocarry		litnotodd
			decrement dest
			decrement source
			copyb (source) to %al	
			copyb %al to (dest)
litnotodd:
		askextradual
		ifnocarry			litquads
			decrement dest
			decrement dest
			decrement source
			decrement source
			copydual (source) to %ax	
			copydual %ax to (dest)
litquads:
		testAND $-4 to Size
		ifzero 						litbail
litquadsloop:
		sub $4 to dest
		sub $4 to source
			copy (source) to A
			copy A to (dest)
		testsubtract DSI to dest
		ifnonzero			litquadsloop
litbail:
	Return


		#==================================
#   max		( a b --- maxab ) Min's hubby.
ATOM_(max,max)
push Size
copy DSI to source		# coming in on the high 
add Size to source
copy DSI to dest
increment Size
maxbyte:
	decrement source
	decrement dest
	decrement Size
	ifnonzero		maxnotdone
		pop Size
		DROP
			Return	
maxnotdone:
	mov (source) to A
	and $255 to A
	mov (dest) to C
	and $255 to C
	sub C to A
	ifzero				maxbyte
	ifcarry 		maxnomush
copy (SP) to  Size
copy DSI to source
add Size to source
copy DSI to dest
maxmushbyte:
        decrement source
        decrement dest
		movb (source) to A
		movb A to (dest)
        decrement Size
        ifnonzero			maxmushbyte
pop Size
DROP
	Return
maxnomush:
	pop Size
	DROP
		Return


		#==================================
#   min		( a b --- min_ab) Max's better half.
ATOM_(min,min)
push Size
copy DSI to source
add Size to source
copy DSI to dest
increment Size
minbyte:
	decrement source
	decrement dest
	decrement Size
	ifnonzero		minnotdone
		pop Size
		DROP
			Return	
minnotdone: 
	mov (source) to A
	and $255 to A
	mov (dest) to C
	and $255 to C
	sub C to A
	ifzero 		maxbyte
	ifnocarry 		minnomush
copy (SP) to  Size
copy DSI to source
add Size to source
copy DSI to dest
minmushbyte:
        decrement source
        decrement dest
		movb (source) to A
		movb A to (dest)
        decrement Size
        ifnonzero			minmushbyte
pop Size
DROP
	Return
minnomush:
	pop Size
	DROP
		Return


		#==================================
#   -		( a b --- a-b )	 2's-complement subtraction of pytes
ATOM_(minus,-)
setsource
DROP
setdest
askcells
ifnonzero 		minusnoncells
	copy (source) to A
	sub A to (dest)
		Return
minusnoncells:
copy Size to counter
askodd
ifnocarry			minusnotodd
	copyb (source) to %al	
	subb %al to (dest)
	pushflags
	increment dest
	increment source
	decrement counter
minusnotodd:
		askextradual
		ifnocarry		minusquads
			copydual (source) to %ax
			pullflags
			sbbw %ax to (dest)
			pushflags
			increment dest
			increment dest
			increment source
			increment source
			decrement counter
			decrement counter
minusquads:
		testAND $-4 to counter
		ifzero 					minusbail
minusquadsloop:
		copy (source) to A
		pullflags
		sbb A to (dest)
		pushflags
		add $4 to dest
		add $4 to source
		sub $4 to counter
		testsubtract $0 to counter
		ifnonzero		minusquadsloop
minusbail:
	pullflags
		Return


		#==================================
#   maskbyte	( a --- a&   0...00ff ) mask off all but lsB
ATOM_(maskbyte,maskbyte)
	copyb  (DSI) to  A
	call zero_no_bump			# SUSPECT
	copyb  A to  (DSI)
		Return


			#==================================
#   move		(P from to |||) (cnt ---) move cnt bytes
ATOM_(move,move)
	copy (DSI) to C
	DROP

	copy (PSI) to A
	PDROP
	copy A to dest
	copy (PSI) to source	
	PBUMP
	testsubtract source to A			#         from -to
        ifcarry 		 move_increasing

	decreasing
	add C to source
	decrement source
	add C to dest
	decrement dest
	jump 		do_move
move_increasing: 
	increasing
do_move: 
	repeating
	   movsb
		Return


			#==================================
#   nip	  NU	( pytea pyteb --- pyteb )  
ATOM_(nip,nip)
	setsource
	DROP
	setdest
	askcells
	ifnonzero			noncell_nip
	   copy (source) to  A
	   copy A to  (dest)
		Return
noncell_nip: 
		add Size to source
		add Size to dest
		askodd
		ifnocarry		nipnotodd
			decrement dest
			decrement source
			copyb (source) to %al	
			copyb %al to (dest)
nipnotodd:
		askextradual
		ifnocarry			nipquads
			decrement dest
			decrement dest
			decrement source
			decrement source
			copydual (source) to %ax	
			copy %ax to (dest)
nipquads:
		testAND $-4 to Size
		ifzero 					nipbail
nipquadsloop:
		sub $4 to dest
		sub $4 to source
			copy (source) to A
			copy A to (dest)
		testsubtract DSI to dest
		ifnonzero		nipquadsloop
nipbail:
	Return


		#==================================
#   -?r		( --- flagpyte )  (R c --- c-1) is TOR nonzero before decrement?
ATOM_(minusaskr,-?r)
	BUMP
	pop A
	add $0 to (%esp)
	ifnonzero				minusaskrTRUE
	decl	(%esp)
	copyb  $0 to (DSI)
		jmp A
minusaskrTRUE: 
	decl	(%esp)
	copyb $255 to (DSI)
		jmp A


		#==================================
#   NOT		( pyte --- !pyte ) bitwise NOT of all bits
ATOM_(Not,NOT)
	setdest
	askcells
	ifnonzero 			noncell_NOT
	   notl (dest)
Return
noncell_NOT: 
		add Size to dest
		askodd
		ifnocarry		NOTnotodd
			decrement dest
			notb (dest)
NOTnotodd:
		askextradual
		ifnocarry		NOTquads
			decrement dest
			decrement dest
			notw (dest)		
NOTquads:
		testAND $-4 to Size
		ifzero 					NOTbail
NOTquadsloop:
		sub $4 to dest
		notl (dest)
		testsubtract DSI to dest
		ifnonzero			NOTquadsloop
NOTbail:
	Return


			#==================================
#   over		( a b --- a b a ) the Forth usual OVER, but on pytes.
ATOM_(over,over)
	DROP
	setsource
	BUMP
	BUMP
	setdest
	askcells
	ifnonzero 	noncell_over
	   copy (source) to  A
	   copy A to  (dest)
		Return
noncell_over: 
		add Size to source
		add Size to dest
		askodd
		ifnocarry		overnotodd
			decrement dest
			decrement source
			copyb (source) to %al	
			copyb %al to (dest)
overnotodd:
		askextradual
		ifnocarry			overquads
			decrement dest
			decrement dest
			decrement source
			decrement source
			copydual (source) to %ax	
			copy %ax to (dest)
overquads:
		testAND $-4 to Size		
		ifzero 					done_over	
overquadsloop:
		sub $4 to dest
		sub $4 to source
			copy (source) to A
			copy A to (dest)
		testsubtract DSI to dest
		ifnonzero			overquadsloop
done_over: 
	Return


			#==================================
#   onbits		( --- -1 )  all_ones pyte constant, 2's compl. -1
ATOM_(onbits,onbits)
	BUMP
	setdest
	askcells
	ifnonzero 			noncell_onbits
	 copy $-1 to (DSI)
Return
noncell_onbits:
	add Size to dest
	askodd
	ifnocarry 			onbitsnotodd	
	decrement dest
	copyb $255 to (dest)
onbitsnotodd:
   	      askextradual
	       ifnocarry		 onbitsquads
	        decrement dest
	        decrement dest
	        copydual $0xffff to (dest)
onbitsquads:
		testAND $-4 to Size
		ifzero 					onbitsbail
onbitsquadsloop:
			sub $4 to dest	
	        	copy $0xffffffff to (dest)
		testsubtract DSI to dest
		ifnonzero 		onbitsquadsloop
onbitsbail:
	Return


		#==================================
#   one		( --- 1	 ) 1 as a pyte constant
ATOM_(one,one)
	BUMP
	setdest			
	askcells
	ifnonzero 		blergitz
	jump 			oneexuent
blergitz:
	add Size to dest
	askodd
	ifnocarry 		onenotodd	
	decrement dest
	copyb $0 to (dest)
onenotodd:
   	      askextradual
	       ifnocarry		 onequads
	        decrement dest
	        decrement dest
	        copydual $0 to (dest)
onequads:
		testAND $-4 to Size
		ifzero 					oneexuent
onequadsloop:
			sub $4 to dest	
	        	copy $0 to (dest)
		testsubtract DSI to dest
		ifnonzero 		onequadsloop
oneexuent:
	copy $1 to (DSI)
		Return


		#==================================
#   OR		( pytea pyteb ---  aORb ) the bitwise Boolean, pytewise
ATOM_(Or,OR)
	setsource
	DROP
	setdest
	askcells
	ifnonzero 		noncell_OR
	   copy (source) to  A
	   or A to (dest)
Return
noncell_OR: 
		add Size to source
		add Size to dest
		askodd
		ifnocarry		ORnotodd
			decrement dest
			decrement source
			copyb (source) to %al	
			orb %al to (dest)
ORnotodd:
		askextradual
		ifnocarry			ORquads
			decrement dest
			decrement dest
			decrement source
			decrement source
			copydual (source) to %ax	
			orw %ax to (dest)
ORquads:
		testAND $-4 to Size
		ifzero 						ORbail
ORquadsloop:
		sub $4 to dest
		sub $4 to source
			copy (source) to A
			or A to (dest)
		testsubtract DSI to dest
		ifnonzero			ORquadsloop
ORbail:
	Return


			#==================================
#   pdrop		(P ptr --- )  decrement pointer stack index
ATOM_(pdrop,pdrop)
	sub $4 to PSI
		Return


			 #==================================

#   port@byte	(P port ||| )     ( --- byte[pytespam] ) x86 wart
ATOM_(portfetchbyte,`por`'t@byte')
	BUMP
	push D
	copy (PSI) to D	
	.byte 0xec
	pop D
	movb %al to (DSI)
		Return


			 #==================================

#   port@dual	(P port ||| )     ( --- dual[pytespam] ) x86 wart
ATOM_(portfetchdual,`po`'rt@dual')
	BUMP
	push D
	copy (PSI) to D	
	.byte 0x66, 0xed
	pop D
	movb %ax to (DSI)
		Return


			 #==================================

#   port@quad	(P port ||| )     ( --- quad[pytespam] ) x86 wart
ATOM_(portfetchquad,`por`'t@quad')
	BUMP
	push D
	copy (PSI) to D	
	.byte 0xed
	pop D
	mov A to (DSI)
		Return


			 #==================================

#   port!byte	(P port ||| )     ( byte[pytespam] --- ) x86 wart
ATOM_(portstorebyte,`p`'ort!byte')
	push D
	movb (DSI) to %al
	copy (PSI) to D	
	.byte 0xee
	pop D
	DROP
		Return


			 #==================================

#   port!dual	(P port ||| )     ( dual[pytespam] --- ) x86 wart
ATOM_(portstoredual,`por`'t!dual')
	push D
	movw (DSI) to %ax
	copy (PSI) to D	
	.byte 0x66, 0xef
	pop D
	DROP
		Return


			 #==================================

#   port!quad	(P port ||| )     ( quad[pytespam] --- ) x86 wart
ATOM_(portstorequad,`po`'rt!quad')
	push D
	copy (PSI) to D	
	.byte 0xef
	pop D
	mov A to (DSI)
	DROP
		Return


		#==================================
#   p@		(P ptr1	 ---  ptr2 ) ptr1 overwritten
ATOM_(pfetch,p@)
	copy (PSI) to A
	copy (A) to A
	copy A to (PSI)
		Return


			#==================================
#   pdup		(P ptra --- ptra ptra )
ATOM_(pdup,pdup)
	copy (PSI) to A
	PBUMP
	copy A to (PSI)
		Return


		#==================================
#   pliteral	(P --- lit )	next cell in thread to P.
 #		pointless from interpreter, needs a threading wrapper.
ATOM_(pliteral,pliteral)
	PBUMP
	pull A
	copy (A) to C
	copy C to (PSI)
	add $4 to A
		jmp A


		#==================================
#   +		( a b --- a+b )	 2's-complement addition of pytes
ATOM_(plus,+)
setsource
DROP
setdest
askcells
ifnonzero 		plus_noncells
	copy (source) to A
	add A to (dest)
			Return
plus_noncells:
copy Size to counter
askodd
ifnocarry			plusnotodd
	copyb (source) to %al	
	addb %al to (dest)
	pushflags
	increment dest
	increment source
	decrement counter
plusnotodd:
		askextradual
		ifnocarry		plusquads
			copydual (source) to %ax
			pullflags
			adcw %ax to (dest)
			pushflags
			increment dest
			increment dest
			increment source
			increment source
			decrement counter
			decrement counter
plusquads:
		testAND $-4 to counter
		ifzero 				plusbail
plusquadsloop:
		copy (source) to A
		pullflags
		adc A to (dest)
		pushflags
		add $4 to dest
		add $4 to source
		sub $4 to counter
		testsubtract $0 to counter
		ifnonzero		plusquadsloop
plusbail:
	pullflags
		Return


			#==================================
#   pover		`pea over'  (P a b --- a b a ) pointer-stack OVER
				# used in p2dup
ATOM_(pover,pover)
	PDROP
	copy (PSI) to A	
	PBUMP
	PBUMP
	copy A to (PSI)
		Return


		#==================================
#   p+		( pyte --- ) (P a --- a+(int_part_or_less_of)pyte
ATOM_(plusp,p+)
	testAND $-4 to Size
	ifzero		pluspunderfour
		mov (DSI) to A
		add A to (PSI)
		DROP		
			Return
pluspunderfour: 
	testsubtract $1 to Size
	ifnonzero		pluspnotone
		mov (DSI) to A
		and $255 to A
		add A to (PSI)
                DROP
                        Return
pluspnotone: 	
	testsubtract $2 to Size
	ifnonzero		pluspthree
		mov (DSI) to A
		and $0xffff to A
		add A to (PSI)
                DROP
                        Return
pluspthree:
		mov (DSI) to A
		and $0xffffff to A
		add A to (PSI)
                DROP
                        Return


		#==================================
#   p+s		(P a --- a+Size ) index a pointer up by Size
ATOM_(ppluss,p+s)
	add Size to (PSI)
		Return


		#==================================
#   p+1		(P a --- a+1 )	index a pointer by one (byte-addressable
ATOM_(pplusb,p+1)
	incl  (PSI)
		Return


		#==================================
#   p+c		(P a --- a+cellsize ) index a pointer by cellsize (x86 is 4
ATOM_(pplusc,p+c)
	add $4 to (PSI)
		Return


		#==================================
#   p-c		(P a --- a-cellsize ) decrement pointer by cellsize (4 on x86
ATOM_(pminusc,p-c)
	subtract $4 to  (PSI)
		Return


		#==================================
#   p-1	NU	(P ptr --- ptr+1 ) decrement a pointer
ATOM_(pminus1,p-1)
	decl (PSI)
		Return


			#==================================
#   p->		(P a --- ) ( --- a_low[a_hi]) assumes cellsize 
ATOM_(pTO,p->)
	BUMP
	movl (PSI) to A
	PDROP
	movl A to (DSI)
		Return



			#==================================
#   p->r		(P a --- ) (R; --- a)    
ATOM_(pTOr,p->r)
	pop A
	pushl (PSI)
	PDROP
		jmp A
      
        
			#==================================
#   p->s		(P Size --- )  !Size  masked to 8 bits
ATOM_(pTOs,p->s)
	movb (PSI) to Size
	PDROP
		Return


		#==================================
#   p!		`pea store' (P    p store ||| )   p --> store
ATOM_(pstore,p!)
	copy (PSI) to A
	PDROP
	copy (PSI) to C
	PBUMP
	copy C to (A)
		Return


			#==================================
#   pswap		(P a b --- b a )
ATOM_(pswap,pswap)
	copy (PSI) to A
	copy -4(PSI) to source
	copy A to -4(PSI)
	copy source to (PSI)
		Return


		#==================================
#   pup		(P ---	oldptr )  pointer stack undrop
ATOM_(pup,pup)
	# look at 4 increments also
	add $4 to  PSI
		Return


			#==================================
#   rdrop		(R; a --- ) 
ATOM_(rdrop,rdrop)
	pop A
	pop source
		jmp  A


			#==================================
#   rpcopy		(R; a ||| ) (P --- a ) dup r to p
			# only used by .r
ATOM_(rpcopy,rpcopy)
	PBUMP
	copy 8(SP) to A
	copy A to (PSI)
        	Return


		#==================================
#   r-1	NU	(R. val --- val-1 )  decrement TOR
ATOM_(rminus1,r-1)
	decl 4(RSI)
		Return


		#===========================================
#   <-r	NU	(R; val --- ) ( --- XXXXval )  4 live bytes written to ds
ATOM_(rTO,<-r)
	pop A
	BUMP
	popl (DSI)
	        jmp A


			#===========================================
#   r->p		(R; ptr --- ) (P --- ptr ) symmetrical with p->r.
ATOM_(rTOp,r->p)
	pop A
	PBUMP
	popl  (PSI)
	push A     
   		Return


			#==================================
#   r->s		(R; size --- )	!SIZE   masked to byte    
ATOM_(rTOs,r->s)
	pop A
	popl Size
	and $255 to Size
        	jmp A


			#==================================
#   swap		( pytea pyteb --- pyteb pytea )
ATOM_(swap,swap)
	DROP
	setsource
	BUMP
	setdest
	askcells
	ifnonzero 			noncell_swap
	   copy (source) to  A
	   copy (dest) to C
	   copy A to (dest)
	   copy C to (source)
Return
noncell_swap:
		add Size to source
		add Size to dest
		askodd
		ifnocarry		swapnotodd
			decrement dest
			decrement source
			   copyb (source) to  %al
			   copyb (dest) to %cl
			   copyb %al to (dest)
			   copyb %cl to (source)
swapnotodd:
		askextradual
		ifnocarry			swapquads
			decrement dest
			decrement dest
			decrement source
			decrement source	
			   copydual (source) to  %ax
			   copydual (dest) to    %cx
			   copydual %ax to (dest)
			   copydual %cx to (source)
swapquads:
		testAND $-4 to Size
		ifzero 					swapbail
swapquadsloop:
		sub $4 to dest
		sub $4 to source
			   copy (source) to  A
			   copy (dest) to C
			   copy A to (dest)
			   copy C to (source)
		testsubtract DSI to dest
		ifnonzero		swapquadsloop
swapbail: 
	Return


			#==================================
#   setSize		( Size --- )  Silently refuses to set Size to  0.
ATOM_(setSize,setSize)
	copyb (DSI) to  Size
	and Size to Size
	ifnonzero		setSizebye
	mov $4 to Size
setSizebye:
	DROP
		Return


			#==================================
#   s->r		(R; --- Size ) Size to Return stack
ATOM_(sTOr,s->r)
	pop A
	push Size
        	jmp A


			#==================================
#   s->p		(P --- Size )  Size to pointer stack
ATOM_(sTOp,s->p)
	PBUMP
	copy Size to (PSI)
		Return


		#==================================
#   !		(P ptr ||| ) ( pyte --- ) pointer is not dropped
ATOM_(store,!)
	copy (PSI) to dest
	setsource
	DROP
	askcells
	ifnonzero		noncell_store
		copy (source) to  A
		copy A to  (dest)
Return
noncell_store: 
		add Size to source
		add Size to dest
		askodd
		ifnocarry		storenotodd
			decrement dest
			decrement source
			copyb (source) to %al	
			copyb %al to (dest)
storenotodd:
		askextradual
		ifnocarry			storequads
			decrement dest
			decrement dest
			decrement source
			decrement source
			copydual (source) to %ax	
			copy %ax to (dest)
storequads:
		testAND $-4 to Size
		ifzero 					storebail
storequadsloop:
		sub $4 to dest
		sub $4 to source
			copy (source) to A
			copy A to (dest)
		testsubtract DSI to dest
		ifnonzero		storequadsloop
storebail:
	Return


		#==================================
#   ->r	NU	(R; --- val ) ( val --- ) Forth >r, ish. 4 bytes moved.
ATOM_(TOr,->r)
	pop A
	push (DSI)
 	DROP
        	jmp A

			#==================================
#   ->code		(P @HNC --- Code_Body_Cell ) useful in Ha3sm?
ATOM_(TOcode,->code)
	XOR	A 	with 	A
	copy   (PSI) to  source
	copyb  (source) to A
	add	A 	to 	(PSI)
	add	$11 	to (PSI)		#  one cell this time
	and 	$-4   to (PSI)
		Return


			#==================================
#   ->link		(P @HNC --- Link_Cell ) `to link' field
ATOM_(TOlink,->link)
	XOR	A 	with 	A
	copy   (PSI) to  source
	copyb  (source) to A
	add	A 	to 	(PSI)
	add	$7 	to (PSI)		#  one cell this time
	and 	$-4   to (PSI)
		Return


		#==================================
#   ->p		(P --- CELL ) ( a --- ) CELLSIZE worth of a is moved
		# used only by &literal, used only in threadtoken
ATOM_(TOp,->p)
	copy (DSI) to  A
	DROP
	PBUMP
	copy A to  (PSI)
		Return


			#==================================
#   true		( --- true_flagpyte ) 0xXXX...ff, true flag pyte constant
ATOM_(true,true)
	BUMP
	copy $255 to (DSI)
		Return


			#==================================
#   2pdrop		(P  A B --- )  drop 2 pointers.
ATOM_(twopdrop,2pdrop)
	subtract $8 to PSI
		Return


			#==================================
#   upshift		( shiftee amount ---  up-shifted [ushhigh] ) 
ATOM_(ushift,ushift)
 push Size
 copyb (DSI)  to %cl			# the shift amount
 DROP
 push DSI
 copy $0 to source			# initialize "low"
 sub $4 to DSI				# got to get on mah good foot
 add $4 to Size
upshloop:
	add $4 to DSI
	copy (DSI) to A
	push (DSI)
	shld source to A
	pop source 
	sub $4 to Size
	ifnonzero		upsmo
		copy A to (DSI)
		pop DSI
	    pop Size
		Return
upsmo:
	testAND $-4 to Size
	ifzero				upsodd
		copy A to (DSI)
		jump 					upshloop
upsodd:
	testAND $2 to Size
	ifzero					nodualups
		movw %ax to (DSI)
		add $2 to DSI
nodualups:
	testAND $1 to Size
	ifzero				exuentups
		movb %al to (DSI)
exuentups:
	pop DSI
	pop Size
		Return

.align 16
		#=============================================

#   x		( pyte --- ) print & drop a pyte, Forth "." but hex only
ATOM_(printhex,x)
	pusha
	copy $numberString to dest 
	copy DSI to PSI
	add Size to DSI
	push Size			# sized to-hex via lookup	
tohexloop:					# for Size...
		decrement DSI
		copy (DSI) to A
		downshift $4 to A
		and $15 to A
		copy digitOut(A) to C
		copy C to (dest)
		increment dest
		copy (DSI) to A
		and $15 to A
		copy digitOut(A) to C
		copy C to (dest)
		increment dest
testsubtract DSI to PSI
ifnonzero				tohexloop
	copy $32 to (dest)
	copy $4 to A
	copy $1 to B
	copy $numberString to C
	pop  D
	upshift D
	increment D
	int $128
	popa
	DROP
		Return


		#==================================
#   XOR		( pytea pyteb ---  aORb ) the bitwise Boolean, pytewise
ATOM_(Xor,XOR)
	setsource
	DROP
	setdest
	askcells
	ifnonzero 		noncell_XOR
	   copy (source) to  A
	   xor A to (dest)
Return
noncell_XOR: 
		add Size to source
		add Size to dest
		askodd
		ifnocarry		XORnotodd
			decrement dest
			decrement source
			copyb (source) to %al	
			xorb %al to (dest)
XORnotodd:
		askextradual
		ifnocarry			XORquads
			decrement dest
			decrement dest
			decrement source
			decrement source
			copydual (source) to %ax	
			xorw %ax to (dest)
XORquads:
		testAND $-4 to Size
		ifzero 					XORbail
XORquadsloop:
		sub $4 to dest
		sub $4 to source
			copy (source) to A
			xor A to (dest)
		testsubtract DSI to dest
		ifnonzero			XORquadsloop
XORbail:
	Return


			#=z=z=z=z==z=z=z=z
#   zero		( --- 0 )   0 as a fast pyte-constant
ATOM_(zero,zero)
	BUMP
	
zero_no_bump:
	setdest			
	askcells
	ifnonzero 		noncell_zero

	 copy $0 to (DSI)
Return
noncell_zero:

	add Size to dest
	askodd
	ifnocarry 			zeronotodd
	decrement dest
	copyb $0 to (dest)
zeronotodd:
   	      askextradual
	       ifnocarry			 zeroquads
	        decrement dest
	        decrement dest
	        copydual $0 to (dest)
zeroquads:
		testAND $-4 to Size
		ifzero 					zerobail
zeroquadsloop:
		sub $4 to dest	
	        copy $0 to (dest)
		testsubtract DSI to dest
		ifnonzero 		zeroquadsloop
zerobail:
	Return



 #  ` end of dictionary build section for fundamentals/atoms/primitives.
 #Begin derived words; threads, named noun instances. The above is the
 #virtual machine, The non-syscall atoms are the virtual CPU.  the
 #following
 #are some things you can do with said machine. Compiled-in threads are
 #written in the assembly language of the VM. Note that some of this
 #proto-H3m code is very un-Forth-like, doing many things wrong. That's
 #because H3m doesn't really exist yet, just the VM. So, it's nasty
 #tortuous virtual assembly. As far as examples of using the H3m
 #interpreter, Note the opcodes used, but ignore the coding style.

#  	SYSCALLS ...


			 #========sssssssssssssssssssssssssssssssss====
ATOM_(thxtebhtxxio,<==SYSCALLS)

#   become		(P  path argv envp ||| ) ( --- GONE|fail=-1) unix execve
HATOM_(become,become)
 BUMP
push A
push B
push C
push D

  #        : "=a" (*(int *)(ds0+dsi))
 #        : "0" (11),"b" ((char *)(ps[psi-2])),"c" ((char *)(ps[psi-1])),
 #          "d" ((char *)(ps[psi]))  );

	copy -4(PSI) to C
	copy $11 to A
	copy (PSI) to D
	copy -8(PSI) to B
	syscall
pop D
pop C
pop B
copy A to (DSI)
pop A
	Return


#   chroot		(P  path |||) ( --- ret) change apparent root directory
ATOM_(chroot,chroot)
 BUMP
push A
push B

  #        : "=a" (*(int *)(ds0+dsi))
 #        : "0" (61),"b" ((char *)(ps[psi]))  );

	copy $61 to A
	copy (PSI) to B
	syscall
pop B
copy A to (DSI)
pop A
Return




#   close		( FD --- ret )  lose and release a filedescriptor
ATOM_(close,close)
push A
push B

 #        : "=a" (*(int *)(ds0+dsi))
 #        : "0" (6),"b" (*(int *)(ds0+dsi))  );

	copy $6 to A
	copy (DSI) to B
	syscall
pop B
copy A to (DSI)
pop A
Return


#   direntries	( FD  count --- red|-1|0 )  (P  buff ||| ) getdents()
HATOM_(direntries,direntries)
 DROP
push A
push B
push C
push D

 #        : "=a" (*(int *)(ds0+dsi))
 #        : "0" (141),"b" ((char *)(ps[psi])),"c" (*(int*)(ds0+dsi+Size)),
 #          "d" (*(int *)(ds0+dsi))  );

	copy (DSI,Size) to C
	copy $141 to A
	copy (DSI) to D
	copy (PSI) to B
	syscall
pop D
pop C
pop B
copy A to (DSI)
pop A
Return


#   dupFD		(old_FD --- new_FID|-1)   unix dup()
ATOM_(dupFD,dupFD)
push A
push B

 #        : "=a" (*(int *)(ds0+dsi))
 #        : "0" (41),"b" (*(int *)(ds0+dsi)) );

	copy $41 to A
	copy (DSI) to B
	syscall
pop B
copy A to (DSI)
pop A
Return


#   fork		parent.. ( ---PID_of_child_or-1)     child.. (--- 0)
ATOM_(fork,fork)
 BUMP

 #        : "=a" (*(int *)(ds0+dsi))
 #        : "0" (2)  );
	copy $2 to A
	syscall
copy A to (DSI)
Return


/* iocontrol		( FD  ioctl --- ret) (P  argp --- )
HATOM_(iocontrol,iocontrol)
 DROP
push A
push B
push C
push D

  #        : "=a" (*(int *)(ds0+dsi))
 #        : "0" (54),"b" (*(int *)(ds0+dsi+Size)),
 #          "c" (*(int *)(ds0+dsi)),
 #          "d" ((char *)(ps[psi]))  );
 #psi--;

	copy (PSI) to D
	copy $54 to A
	copy (DSI) to C
	copy (DSI,Size) to B
	syscall
pop D
pop C
pop B
copy A to (DSI)
pop A
PDROP
Return


/* makedir		(P name ||| )  ( --- flag)   unix mkdir(), perms==0
HATOM_(makedir,makedir)
 BUMP
push A
push B
push C

 #        : "=a" (*(int *)(ds0+dsi))
 #        : "0" (39),"b" ((char *)(ps[psi])),"c" (0) );

	copy $0 to C
	copy $39 to A
	copy (PSI) to B
	syscall
pop C
pop B
copy A to (DSI)
pop A
Return


#   mount		(P special dir fstype|NULL data |||)
HATOM_(mount,mount)

push A
push B
push C
push D
push %esi
push %edi

 #i = ps[psi-3];                  /* special file         */
  #j = ps[psi-2];                  /* mountpoint           */
 #k = ps[psi-1];                  /* fstype|NULL          */
 #K = ps[psi];                    /* r/w flags            */
 #e = *(int *)(ds0 + dsi);        /* data                 */
 #        : "=a" (*(int *)(ds0+dsi))
 #        : "0" (21),"b" (i),"c" (j),"d" (k),"D" (e),
 #                "S" (K )  );

	copy (DSI) to %edi
	copy (PSI) to %esi
	copy -4(PSI) to D
	copy -8(PSI) to C 
	copy $21 to A
	copy -12(PSI) to B
	syscall

pop %edi
pop %esi
pop D
pop C
pop B
copy A to (DSI)
pop A
Return


#   nanosleep	(P  timespec remaining ||| )    ( --- flag )
HATOM_(nanosleep,nanosleep)
 BUMP
push A
push B
push C

 #        : "=a" (*(int *)(ds0+dsi))
 #        : "0" (162),"b" ((char *)(ps[psi-1])),
  #                    "c" ((char *)(ps[psi]))  );

	copy (PSI) to C
	copy -4(PSI) to B
	copy $162 to A
	syscall
pop C
pop B
copy A to (DSI)
pop A
Return


#   owner		(P path |||)   ( UID  GID --- ret)  unix chown()
HATOM_(owner,owner)
 DROP
push A
push B
push C
push D

 #        : "=a" (*(int *)(ds0+dsi))
 #        : "0" (182),"b" ((char *)(ps[psi])),
 #          "c" (*(int *)(ds0+dsi+Size)), 
 #          "d" (*(int *)(ds0+dsi))  );

	copy (DSI,Size) to C
	copy $182 to A
	copy (DSI) to D
	copy (PSI) to B
	syscall
pop D
pop C
pop B
copy A to (DSI)
pop A
Return


#   pause		( --- -1 )      wait for a signal
ATOM_(pause,pause)
 BUMP

 #        : "=a" (*(int *)(ds0+dsi))
 #        : "0" (29) );

	copy $29 to A
	syscall
copy A to (DSI)
Return


#   parent		( --- parent_PID )      unix getppid()
ATOM_(parent,parent)
 BUMP

 #        : "=a" (*(int *)(ds0+dsi))
 #        : "0" (64)      );

	copy $64 to A
	syscall
copy A to (DSI)
Return


#   permit		(P path |||)   ( mode --- ret)   unix chmod()
HATOM_(permit,permit)
push A
push B
push C

 #        : "=a" (*(int *)(ds0+dsi))
 #        : "0" (15),"b" ((char *)(ps[psi])),
 #                   "c" (*(int *)(ds0+dsi)) );

	copy (DSI) to C
	copy $15 to A
	copy (PSI) to B
	syscall
pop C
pop B
copy A to (DSI)
pop A
Return


#   pipe		(P ptr_to_int[2] |||)  ( --- flag) 2 FD's in given
HATOM_(Spipe,Spipe)
 BUMP
push A
push B

 #        : "=a" (*(int *)(ds0+dsi))
 #        : "0" (42),"b" ((char *)(ps[psi])) );

	copy $42 to A
	copy (PSI) to B
	syscall
pop B
copy A to (DSI)
pop A
Return


#   rename		(P old new |||) ( --- flag ) basis of mv
ATOM_(rename,rename) 
 BUMP
push A
push B
push C

 #        : "=a" (*(int *)(ds0+dsi))
 #        : "0" (38),"b" ( (char *)(ps[psi-1]) ),
 #                   "c" ( (char *)(ps[psi]) )

	copy -4(PSI) to B
	copy $38 to A
	copy (PSI) to C
	syscall
pop C
pop B
copy A to (DSI)
pop A
	Return


#   todir		(P path --- ) (--- ret)  unix chdir(), cd
ATOM_(todir,todir)
 BUMP
push A
push B

 #        : "=a" (*(int *)(ds0+dsi))
 #        : "0" (12),"b" ((char *)(ps[psi]))  );

	copy $12 to A
	copy (PSI) to B
	syscall
pop B
copy A to (DSI)
pop A
	Return


#   readlink	(P name buff ||| ) ( bufsize --- flag )  unix readlink
ATOM_(readlink,readlink)
push A
push B
push C
push D

 #        : "=a" (*(int *)(ds0+dsi))
 #        : "0" (85) ,"b" ((char *)(ps[psi-1])),"c" ((char *)(ps[psi])),
 #                "d" ( *(int *)(ds0+dsi) )  );

	copy (PSI) to C
	copy $85 to A
	copy (DSI) to D
	copy -4(PSI) to B
	syscall
pop D
pop C
pop B
copy A to (DSI)
pop A
Return


#   response	( sig# --- flag ) (P action old |||) install a signal
ATOM_(response,response)
push A
push B
push C
push D

 #i = (ps[psi-1]);
 #j = (ps[psi]);

 #        : "=a" (*(int *)(ds0+dsi))
 #        : "0" (67),"b" (* (int*)(ds0+dsi) ),
 #                   "c" (i),
 #                   "d" (j) );

	copy -4(PSI) to C
	copy $67 to A
	copy (PSI) to D
	copy (DSI) to B
	syscall
pop D
pop C
pop B
copy A to (DSI)
pop A
Return


#   socketcall	( call --- flag )  (P args ||| ) socket calls entry
HATOM_(socketcall,socketcall)
push A
push B
push C

 #        : "=a" (*(int *)(ds0+dsi))
 #        : "0" (102), "b" (*(int *)(ds0+dsi)),
  #                     "c" (ps[psi])              );

	copy (PSI) to C
	copy $102 to A
	copy (DSI) to B
	syscall
pop C
pop B
copy A to (DSI)
pop A
Return


#   special		(P name |||)    ( mode dev --- flag )   unix mknod
ATOM_(special,special)
 DROP
push A
push B
push C
push D

 #        : "=a" (*(int *)(ds0+dsi))
  #        : "0" (14),"b" (*(int *)(ps[psi])),"c" (*(int *)(ds0+dsi)),
 #                "d" (*(int *)(ds0+dsi+Size)) );

	copy (DSI,Size) to D
	copy $14 to A
	copy (DSI) to C
	copy (PSI) to B
	syscall
pop D
pop C
pop B
copy A to (DSI)
pop A
Return



#   stat		(P name buff ||| ) ( --- flag) get a file's stat
ATOM_(stat,stat)
 BUMP 
push A
push B
push C

 #        : "=a" (*(int *)(ds0+dsi))
 #        : "0" (106),"b" (*(int *)(ps[psi-1])),
 #                "c" (*(int *)(ps[psi])) );

	copy (PSI) to C
	copy $106 to A
	copy -4(PSI) to B
	syscall
pop C
pop B
copy A to (DSI)
pop A
Return


#   lose		(P name ||| ) ( --- flag) rm a name, maybe thedata
 #                        inode */
 #                        /* a hardlink is a name of an inode. unlink
 #                                the last one and unix frees the inode
ATOM_(lose,lose)
 BUMP
push A
push B

 #        : "=a" (*(int *)(ds0+dsi))
 #        : "0" (10), "b" ((char *)(ps[psi])) );

	copy $10 to A
	copy (PSI) to B
	syscall
pop B
copy A to (DSI)
pop A
Return


#   unmount		(P name ||| )   ( --- flag) unix umount()
HATOM_(unmount,unmount)
push A
push B

 #        : "=a" (*(int *)(ds0+dsi))
 #        : "0" (22), "b" ((char *)(ps[psi])) );

	copy $22 to A
	copy (PSI) to B
	syscall
pop B
copy A to (DSI)
pop A
Return



#   symlink		(P exists new |||)  ( --- flag )
HATOM_(symlink,symlink)
push A
push B
push C

 #        : "=a" (*(int *)(ds0+dsi))
 #        : "0" (83),"b" (*(int *)(ps[psi-1])),
 #                "c" (*(int *)(ps[psi])) );

	copy (PSI) to C
	copy $83 to A
	copy -4(PSI) to B
	syscall
pop C
pop B
copy A to (DSI)
pop A
Return


#   waitpid		(pid options --- ret )  simplified
ATOM_(waitpid,waitpid)
 DROP
push A
push B
push C
push D

 #        : "=a" (*(int *)(ds0+dsi))
 #        : "0" (7),"b" (*(int *)(ds0+dsi+Size)),"c" (0),
 #          "d" (*(int *)(ds0+dsi)) );

	copy (DSI) to D
	copy $0 to C
	copy (DSI,Size) to B
	copy $7 to A
	syscall
pop D
pop C
pop B
copy A to (DSI)
pop A
	Return


#   rmdir		(P name ||| )   ( --- flag )  remove empty dir
HATOM_(rmdir,rmdir)
 #BUMP
push A
push B

 #        : "=a" (*(int *)(ds0+dsi))
 #        : "0" (40), "b" ( (char *)(ps[psi]) ) );

	copy $40 to A
	copy (PSI) to B
	syscall
pop B
copy A to (DSI)
pop A
Return


#   seek		( FD o/s whence --- o/s0 ) unix lseek, reposition-file 
ATOM_(seek,seek)
 DROP 
 DROP
push A
push B
push C
push D

 #        : "=a" (*(int *)(ds0+dsi))
 #        : "0" (19),"b" (*(int *)(ds0+dsi)),
 #                   "c" (*(int *)(ds0+dsi+Size)),
 #                   "d" ( *(int *)(ds0+dsi+Size+Size) )        );

	copy (DSI,Size,2) to C
	copy $19 to A
	copy (DSI,Size) to D
	copy (DSI) to B
	syscall
pop D
pop C
pop B
copy A to (DSI)
pop A
Return


#   signal		( PID signal --- ret)   unix kill
ATOM_(signal,signal)
 DROP
push A
push B
push C
push D

 #        : "=a" (*(int *)(ds0+dsi))
 #        : "0" (37),"b" (*(int *)(ds0+dsi+Size)),"c" (0),
 #          "d" (*(int *)(ds0+dsi)) );

	copy (DSI,Size) to B
	copy $37 to A
	copy (DSI) to D
	copy $0 to C
	syscall
pop D
pop C
pop B
copy A to (DSI)
pop A
Return


#   open_		(P name |||)  ( flags perms --- FD ) see open thread
ATOM_(open_,open_)
DROP 
push A
push B
push C
push D
	copy (DSI,Size) to C
	copy $5 to A
	copy (DSI) to D
	copy (PSI) to B
	syscall
pop D
pop C
pop B
copy A to (DSI)
pop A
Return


#   quit		unix exit, Forth bye, H3m quit. q. works.	KG
ATOM_(quit,quit)
	mov (DSI) to %ebx
	mov $1 to %eax
	int $128
	# *poof*


#   read		( FD --- red ) (P buf ||| ) requests 2048 bytes
ATOM_(read,read)
push A
push B
push C
push D
	copy $3 to A
	copy (DSI) to B
	copy (PSI) to C
	copy $2048 to D
	syscall
pop D
pop C
pop B
copy A to (DSI)
pop A
	Return


#   write		( FDbyte  request --- wrote )   (P name ||| )
ATOM_(write,write)
DROP 
push A
push B
push C
push D
	copy (DSI,Size) to D
	copy $4 to A
	copy (DSI) to B
	copy (PSI) to C
	syscall
pop D
pop C
pop B
copy A to (DSI)
pop A
Return


ATOM_(thxbtixio,<<<THREADS)


 #   7777777777777777777777777777777777777777777777777777
 #   end of dictionary build section for fundamentals/atoms/primitives.
 #Begin derived words; threads, named noun instances. The above is the
 #virtual machine, The non-syscall atoms are the virtual CPU.  the
 # following are some things you can do with said machine. Compiled-in
 # threads are written in the assembly language of the VM. Note that some
 # of this proto-H3m code is very un-Forth-like, doing many things wrong.
 # That's because H3m doesn't really exist yet, just the VM. So, it's
 # nasty tortuous virtual assembly. As far as examples of using the H3m
 # interpreter, Note the opcodes used, but ignore the coding style. Very
 # important in Virtual Machine Subroutine Threading, above here (by
 # default words have the atomic bit set in the Head Name Interface Cell.


 #   contents of this int is given by  arg
define(CELL,
.int $1
)


 #   this cell contains CFA of word named as argument
define(OP,	call $1	)

define(BYTE,    .byte `$1'       )

define(ELL, jmp $1 )

define(YES,
`	mov (DSI), %eax	
	DROP
	and `$'255, %eax'
	jnz $1
)		


define(NO,
`	mov (DSI), %eax	
	DROP
	and `$'255, %eax'
	jz $1
)



 #   VMST jsr, takes a whole cell, + the callee's cell
 #This doesn't have the OP folded into it to keep branch offset counting
 #1/1, except for branch targets. ___o___


#  	NAMED DATA...
 #  ddddddddddddddddddddddddddddddd============

quadalign


#   ARGV		(P --- &argv[] )
NON_USER(ARGV,ARGV)
call address
.org . + 256 
quadalign



#   arglast		(P --- &argv[] )
NON_USER(arglast,arglast)
call address			# set to dp+oh, 1k or so on command
.org . + 16 
quadalign



#   block		(P --- begin_buffer) object data buffer(s
THREAD_(block,block)
call address
.org . + 1024


#   buffer		(P --- begin_buffer) "file" input buffer
THREAD_(buffer,buffer)
call address
bufferlabel:
.org . + 1024


#   bsi		counter for branches to resolve
NON_USER(bsi,bsi)
call address
.int 0


#   branchstack	space for 16 branches to resolve
NON_USER(branchstack,branchstack)
call address
CELL(0)
.org . + 128


#   digits		(P  ---	 address_of_array ) ascii vals to hex vals map
THREAD_(digits,digits)
call address
CELL( 9 ) CELL( 0 ) CELL( 0 ) CELL( 0 )
CELL( 0 ) CELL( 0 ) CELL( 0 ) CELL( 0 )
CELL( 0 ) CELL( 0 ) CELL( 0 ) CELL( 0 )
ENDIANCELL(0x00,0x01,0x02,0x03)
ENDIANCELL(0x04,0x05,0x06,0x07)
ENDIANCELL(0x08,0x09,0x00,0x00)
CELL( 0 )
CELL( 0 ) CELL( 0 ) CELL( 0 ) CELL( 0 )
CELL( 0 ) CELL( 0 ) CELL( 0 ) CELL( 0 )
ENDIANCELL(0x00,0x0a,0x0b,0x0c)
ENDIANCELL(0x0d,0x0e,0x0f,0x00)
CELL( 0 ) CELL( 0 ) CELL( 0 ) CELL( 0 )
CELL( 0 ) CELL( 0 ) CELL( 0 ) CELL( 0 )
CELL( 0 ) CELL( 0 ) CELL( 0 ) CELL( 0 )
CELL( 0 ) CELL( 0 ) CELL( 0 ) CELL( 0 )


#   dp		(P --- dictionary_free-point_pointer )  pointer, unlike HERE
THREAD_(dp,dp)
call address
dpaddy: 		#   we have to poke a number in here at init time
.int initialdp + 100
CELL(0)
quadalign


#   epa		(P --- @epa )  End Parse Area	pointer
THREAD_(epa,epa)
 #    can't just keep these on a stack because of doHNC
call address
epal: 
CELL(0)
quadalign


#   ENVP		(P --- &envp[]
THREAD_(ENVP,ENVP)
call address
envp:
CELL(0)
.org . + 256 
quadalign

#   EOL
NON_USER(EOL,EOL)
call address
CELL(10)
quadalign


#   hexdigits	(P  ---	 &array )  ascii val is/not a hex digit

THREAD_(hexdigits,hexdigits)
call address
CELL( 0 ) CELL( 0 ) CELL( 0 ) CELL( 0 )
CELL( 0 ) CELL( 0 ) CELL( 0 ) CELL( 0 )
CELL( 0 ) CELL( 0 ) CELL( 0 ) CELL( 0 )
ENDIANCELL(0xff,0xff,0xff,0xff)
ENDIANCELL(0xff,0xff,0xff,0xff)
ENDIANCELL(0xff,0xff,0x00,0x00)
CELL( 0 )
CELL( 0 ) CELL( 0 ) CELL( 0 ) CELL( 0 )
CELL( 0 ) CELL( 0 ) CELL( 0 ) CELL( 0 )
ENDIANCELL(0x00,0xff,0xff,0xff)
ENDIANCELL(0xff,0xff,0xff,0x00)
CELL( 0 ) CELL( 0 ) CELL( 0 ) CELL( 0 )
CELL( 0 ) CELL( 0 ) CELL( 0 ) CELL( 0 )
CELL( 0 ) CELL( 0 ) CELL( 0 ) CELL( 0 )
CELL( 0 ) CELL( 0 ) CELL( 0 ) CELL( 0 )
quadalign


#   historybuffer
NON_USER(historybuffer,historybuffer)
call address 
CELL(0)
.org . + 128
quadalign

#   historyname
NON_USER(historyname,historyname)
call address 
.ascii "H3story\000"
quadalign

#   historychars
NON_USER(historychars,historychars)
call address
CELL(0)
quadalign

#   historyFD
NON_USER(historyFD,historyFD)
call address
CELL(0)
quadalign


#   latest		(P --- @HNC ) addr. of HNC of most recent definition
THREAD_(Latest,latest)
call address		#   data word, does it's own Return.
latest: 			#   C needs this address for init code
CELL(0)
quadalign


#   Null		(P --- &0 )  a pointer to a zero 
THREAD_(Null,Null)
call address
.int .
CELL(0)
CELL(0)
quadalign


#   pvar		(P --- \&pvar)	scratch pointer for thread resolver
NON_USER(pvar,pvar)
call address
 CELL(0)
quadalign


#   rcfile		(P --- &"rcfile"
THREAD_(rcfile,rcfile)
call address
.ascii   "initH3sm\000"
CELL(0)
quadalign


#   SOURCE		(P --- &input_FD) pointer to FD of source of input
THREAD_(Source,`s`'ource')
call address
CELL(0)
quadalign

.org . + 200

#   thispointer	(P --- &this ) current address in buffered parse area
THREAD_(thispointer,thispointer)
call address
thisl: 
CELL(0)
quadalign


#   toklen		token length
THREAD_(toklen,toklen)
call address
CELL(0)
quadalign


#   timespec
THREAD_(timespec,timespec)
call address
CELL(0)				# timespec
CELL(1000)
CELL(0)				# remaining
CELL(0)
CELL(0)
CELL(0)
quadalign


#   targetstack	space for 8 addresses to resolve branches to
NON_USER(targetstack,targetstack)
call address
CELL(0)
.org . + 128 
quadalign
	#   allot for a maximal pyte


#   tokenbuffer	(P --- &token ) where we stash an input token
THREAD_(tb,tb)
call address
CELL(0)
.org . + 1024 
quadalign


#   tsi		counter for branches to resolve
NON_USER(tsi,tsi)
call address
CELL(0)
quadalign


#   USize		(P --- @USize ) offstack Size store for interpreter
NON_USER(USize,USize)
call address
CELL(4)				#   x86 cell size
quadalign


#  	THREADS...
 #   TTTTTTTTTTTTTTTTTTTTTTTT============

#   &		( a --- )  !dp	 `append' a into dictionary at &dp at Size
THREAD_(append,``&'')
call dp			#  (P &dp)		( a )
call pdup		#  (P &dp &dp)		( a )
call pfetch		#  (P &dp dp)		( a )
call store		#  (P &dp dp)		()
call ppluss		#  (P &dp dp')		()
call pswap		#  (P dp' &dp)
call pstore		#  (P dp' &dp)		!dp
call twopdrop		#  (P;)
	Return


   # ttttttttttttttttttttttt============

#   &call

THREADING(appendcall,&call)

call sTOr
call bytes
call literal
.byte 1
.byte 0xe8
call append
call bump
call rTOs
call drop
call true
	Return


   # ttttttttttttttttttttttt============

#   &literal	`append literal'  ( # --- )   !dp

THREAD_(appendlit,``&literal'')
call sTOr
call cells
call appendcall
call drop
call pliteral			# r->pCFA
.int literalCFA
call dp
call pfetch
call pplusc			# r->pCFA ret

call gap
call append

call bump
call rTOs
call drop

call twopdrop
call appendSize
call append		# ( )		(P )		!dp
	Return


   # ttttttttttttttttttttttt============

#   &return

THREADING(appendre`tu'rn,`&re`'turn')

call sTOr
call bytes
call literal
.byte 1
.byte 0xc3
call append
call bump
call rTOs
call drop
call true
	Return


   # ttttttttttttttttttttttt============

THREAD_(appendSize,&``S''ize)
call getSize
call sTOr
call bytes
call pTO
call append

call bump
call rTOs
call drop
        Return


   #ttttttttttttttttttttttt============

#   &$ 		"&$ string!%(!^$ "  append string literal to dict. */ 
THREADING(appendshegment,&$)

call appendcall

call dp				# &dp
call pfetch			# $
call pdup			# $ $	
call pplusc			# $ $+c
call literal
 BYTE(4)
 CELL(0x24)
call delimit			# $  $+c		count did
call drop			# $  $+c		count
call dup				# $  $+c		count count
call plusp			# $  $+c+count		count	
call dp				# $  $+c+count dp
call pstore

call twopdrop			# $  			count
call store			# $	    !relcall  		
call pdrop

call appendcall

call pliteral			# r->pCFA
.int rTOpCFA
call dp
call pfetch
call pplusc			# r->pCFA ret
call gap
call append
call twopdrop
call true
	Return


   # ttttttttttttttttttttttt============

#   &word		(P &HNC ||| ) assemble/append a word token
THREAD_(appendword,&word)
call pdup
call TOcode
 #         append a relative call
call sTOr
call bytes
call literal
 .byte 1
 .byte 0xe8

call append
call cells
call dp
call pfetch
call pplusc
call gap
call append
call rTOs
call twopdrop
	Return


   # ttttttttttttttttttttttt============

#   &pliteral	thread-time -> "&pliteral lit# " THREADING
THREADING(appendpliteral,&pliteral)
call sTOr
call cells
call literal
 BYTE(4)		# pliteral's CFA as literal. Hmmmmm.
 CELL(pliteralCFA)	# (  plitCFA )
call TOp			# (P plitCFA )
call appendp		 # (P plitCFA )
call pdrop		#
call token
call hexnumber
call append
call rTOs
	Return


   # ttttttttttttttttttttttt============

#   &p		(P bla |||  )	append pointer bla to dictionary  !dp
THREAD_(appendp,&p)

call dp			#	(P bla &dp)
call pdup		#	(P bla &dp &dp)
call pTOr		#	(P bla &dp)	(R; &dp)
call pfetch		#	(P bla	dp)	(R; &dp)
call pstore		#	(P bla	dp)	(R; &dp)   !HERE
call pplusc		#	(P bla	dp')	(R; &dp)
call rTOp		#	(P bla	dp' &dp)
call pstore		#	(P bla	dp' &dp)    !dp
call twopdrop
	Return


   # TTTTTTTTTTTTTTTTTTTTTTTT============

#   allot		( o/s --- )  move dp up o/s bytes. iffy at > 256
THREAD_(allot,allot)
call dp
call pdup
call pfetch
call plusp
call pswap
call pstore
	Return


   # tttttttttttttttttttttt============

#   argument	"arg. bla " stash a C/unix argument token 
THREAD_(argument,argument)

call token
call zeroterminate
call tb				
call arglast
call pfetch
call toklen
call fetch
call pdrop
call one
call plus
call dup
call move

call plusp
call arglast
call pstore
call twopdrop
call pdrop

	Return


	   # tttttttttttttttttttttt============

#   argswipe	()	set args list to  0
THREAD_(argswipe,argswipe)
	call pad
	call ARGV
	call pstore
		Return


   # tttttttttttttttttttttt============

#   asciinybble	( --- nybble )	(P char	 ||| )
THREAD_(asciiTOdigit,asciinybble)
call fetch		#   ( pyte		(P
call maskbyte		#   ( byte		(P
call digits		#   ( byte		(P  array
call plusp		#   (			(P indexed


call fetch		#   ( nybblepyte	(P


call pdrop
call maskbyte		#   ( nybble		(P
	Return


   # ttttttttttttttttttttttt============

#   ?hexnumber	( --- flag )  @'s toklen and tb
THREAD_(ifhexnumber,?hexnumber)
call tb
call toklen
call fetch			#  (toklen )	(P bt )
call pdrop
call one				#  (toklen 1)	(P bt )
call plus			#  (pre-count) (P bt )
ifhexnum:
	call onbits		#   ( count -1 )   (P bt )
	call plus		#   ( count')		(P bt )
	call dup			#   ( count' count')	(P bt )
	NO(		thlangle)
	call ifhex		#   ( count' flag )	(P bt )
	call pplusb		#   ( count' flag )	(P cur.char )
	NO(		heptuna)
ELL(			ifhexnum)
thlangle:
		call drop	# done, is number   () (Pbeg.tok)
		call pdrop	#   ()		(P)
		call true	#   (xxxff)	(P)
			Return
heptuna:
	call drop		# not a number (count	(P array )
	call pdrop		#   (	(P)
	call false		#   (	xxx00 )		(P)
		Return


   # tttttttttttttttttttttttttttttttttttttttt============

#   ?file		STUB ( --- flag ) "iffile  token "
NON_USER(iffile,?file)
call false
	Return


   # ttttttttttttttttttttttt============

#   ?threader	(P &HNC |||) ( --- flag ) true if threader word
THREAD_(ifthreader,?threader)
call pdup		# (P &HNC ||| &HNC
call pfetch		# (P &HNC ||| HNC
call pTO			# (P HNC |||) ( HNC )
call literal
 BYTE(4)
 CELL(0x00000100)	# (P HNC |||) ( HNC abit)
call And			# (P HNC |||) ( ?theader )
call flag		# (P HNC |||) ( flag )
	Return


   # ttttttttttttttttttttttttttttttttttttttttttttttttttttt============

#   ?pending	(--- flag) true if not finished refill	  @this @epa
THREAD_(ifpending,?pending)

call thispointer
call pfetch
call epa
call pfetch
call gap
call flag
call twopdrop
	Return


   # ttttttttttttttttttttttttttttttttttttttttttttttttttttt============

#   ?$=		(P beg.	 beg. ||| --- ) ( len ||| --- flag ) are memory segments =?
THREAD_(ifsegmentsequal,?$=)

call dup					# ( len )
call one
call plus				# ( downcounter )
call p2dup				# ( downcounter )   (P str str
stringsequal:
	call onbits			# ( dc -1		(P str str
	call plus			# ( dc-1		(P str str
	call dup				# ( dc-1 dc-1		(P str str
	NO(		tueioobhx)
	call ifcontentsequal    		# ( dc-1 flag		(P str str
	 call p2pluss			# ( dc-1 flag		(P str' str'
YES(			stringsequal)
	call twopdrop			# ( dc-1		(P.)
	call drop			# ( )
	call false			# ( false)
		Return
tueioobhx:
		call twopdrop		# ( false		(P )
		call drop		# ( )
		call true		# ( true)
			Return


   # ttttttttttttttttttttttt============

#   ?byte$=		(P beg.	 beg. |||) (len ||| --- flag)255 max len
THREAD_(ifbytesegmentsequal,?byte$=)

call dup					# ( len )
call sTOr
call drop
call bytes	# SUSPECT_				# bytes context
call bump
call one					# ( len 1 )
call plus				# ( downcounter )
call p2dup				# ( downcounter )   (P str str
bytestringsequal:
	call onbits			# ( dc -1		(P str str
	call plus			# ( dc-1		(P str str
	call dup				# ( dc-1 dc-1		(P str str
	NO(		cteuk)
	call ifcontentsequal		# ( dc-1 flag		(P str str
	 call p2pluss			# ( dc-1 flag		(P str' str'
YES(		bytestringsequal)
call twopdrop				# ( dc-1		(P.)
call rTOs
call drop
call false				# ( false)
	Return
cteuk:
		call twopdrop		# ( dc-1=0		(P )
		call rTOs
		call drop
		call true		# ( true)
			Return


   # ttttttttttttttttttttttt============

#   ?char		(p; str --- )  ( --- flag )  true if byte > 32
THREAD_(ifchar,?char)
call fetch		# (P str ) ( char ) (R: ParentSize ) !Size
call pdrop
call maskbyte
call literal
  BYTE(4)
  CELL(32)		# ( byte  32  )

call min		# ( 0_or_ischar)
call literal
  BYTE(4)
  CELL(32)		# ( byte  32  )
call ifequal
call aint
	Return


   # tttttttttttttttttttttttt  ============

#   ?word		(P ---	HNC|null) ( --- flag )
THREAD_(ifword,?word)
call tb			#   (P tb )
call toklen		#   (P bt toklen)		(R oS
			#	this limits toklen to 255.
call fetch		#   (P bt )  ( toklen)		(R oS
call pdrop
call maskbyte
call Latest
call pfetch		#   (P bt latest ) ( toklen )	(R oS
while_dictionary:
	call fetch		#   (P bt latest ) ( len namebyte )
	call maskbyte
	YES(		fliffle)
				# len=0=aardvark
		call drop	#   (P bt latest )	()
		call false	#   (P bt latest )	( false )
		call twopdrop	#   (P) = NULL		(false )
			Return
fliffle:
	call fetch		#   (P tbt  last) ( toklen  namelen  )
	call maskbyte	
	call over		#   (P tb  last ) ( toklen  namelen toklen
	call ifequal		#   (P tb  last ) ( toklen  flag )
	NO(		tchuzz)	# not the same length as this name

				# same length
	call pplusc		#   (P begintoken  name ) ( toklen )	
	call ifbytesegmentsequal
	NO(		spnoift)	
				# MATCH
	call pswap		#   (P name tb)	( toklen )
	call pdrop		#   (P name)		( toklen )	
	call pminusc		#   (P HNC )		( toklen )
	call drop		#   (P HNC ) ()
	call true		#   (P HNC ) ( TRUE )
		Return
spnoift:
				#from  asksegmentsequal
	call pminusc		#   (P begintok this_HNC)  (toklen )
tchuzz:				#   from askequal
	call TOlink		#   "previous"
	call pfetch		#   (P bt HNC' ) (toklen )
ELL(			while_dictionary)


   # ttttttttttttttttttttttttttttttttttttttttttttttttttt============

#   beep		emit a 7, ASCII `BEL', C \a		
THREAD_(beep,beep)
call literal 
.byte 4 
.int  7 
call emit 
	Return


   # ttttttttttttttttttttttt============

#   blank		emit a blank character, 0x20, a space
THREAD_(blank,blank)
call literal 
 BYTE(4) 
 CELL(32) 
call emit 
	Return


   # tttttttttttttttttttt============

#   :		": ccc H3sm.. ; " name/link ccc, set target 0, start threader
THREAD_(colon,:)
			# wipe branch-resolver stacks

call dp			# x86ism. align the thread.
call pdup
call pfetch
call align
call pswap
call pstore
call twopdrop

call initresolve
call header
call link
			# stash newguy's CFA as target0
call target
call drop
call threadloop
	Return


   # ttttttttttttttttttttttt============

#   cr		emit a (unix) newline
THREAD_(cr,cr)
call literal 
 BYTE(4) 
 CELL(10) 
call emit 
	Return


   # ttttttttttttttttttttttt============

#   dofile
NON_USER(dofile,dofile)
call sTOr
call cells
call zeroterminate
call tb
call todir
call flag
YES(				notdir)
	call rTOs
	call true
		Return
notdir:
call fork
call flag		# happens in parent and child
YES(							dofileparent)
					# child process
	call tb
	call Null
	call Null
	call become			    # command
		call parent
		call quit

dofileparent:				# parent
			call wait		# block till signal
			call rTOs
			call true 
				Return


   # ttttttttttttttttttttttttttttttttttttttt============

#   dump		(P start --- end ) hexdump 256 bytes, continuable
THREAD_(dump,dump)

call literal
 .byte  4
 .int   16
call TOr
dumpit:
	call dumpline		#  (P	a'' )
	call literal
	 .byte 4
	 .int 124
	call emit
	call minusaskr
	NO(	dumpdump)
ELL(			dumpit)
dumpdump:
		call rdrop
		call cr
			Return


   # ttttttttttttttttttttttttttttttttttt===========

#   dumpline	(P a --- a+16 )	 display 16 bytes from a
NON_USER(dumpline,dumpline)

call sTOr
call drop
call cells
call bump
call pdup
call cr
call printp
call blank
call blank
call drop
call bytes   # SUSPECT__
call bump
call fetchplus	
call printhex 
call fetchplus	
call printhex
call fetchplus	
call printhex 
call fetchplus	
call printhex
call fetchplus	
call printhex 
call fetchplus	
call printhex
call fetchplus	
call printhex 
call fetchplus	
call printhex
call fetchplus	
call printhex 
call fetchplus	
call printhex
call fetchplus	
call printhex 
call fetchplus	
call printhex
call fetchplus	
call printhex 
call fetchplus	
call printhex
call fetchplus	
call printhex 
call fetchplus	
call printhex
			# (P  a  a+16)
call blank 	
call blank
call literal
  .byte 4
  .int 124
call emit
call pswap				# (P a+16 a )
call literal
 .byte 4 
 .int 15
call printchars
call rTOs
call pdrop				# (P a+16)
	Return


   # ttttttttttttttttttttttt============

#   dpdump		(P --- dp+0xc0 )   dump from dp - 0x80
THREAD_(dpdump,dpdump)
call dp
call pfetch
call literal
 .byte 4
 .int  0x80
call Negate
call plusp
call literal
 .byte 4
 .int 7
call TOr
mdump:
	call dumpline
	call literal
	 .byte 4
	 .int  124
	call emit
	call minusaskr
	NO(	aodump)
ELL(	   			mdump)
aodump:
call rdrop
call cr
call literal
.byte 4
.int 8
call TOr
mdump2:
	call dumpline		#  (P	a'' )
	call literal
	.byte 4
	.int 124
	call emit
	call minusaskr
	NO(		tatadump)
ELL(	   			mdump2)
tatadump:
call rdrop
call cr
	Return


   # ttttttttttttttttttttttt============

#   delimit		(P dest |||) ( delimiter --- count did ) stash input
THREAD_(delimit,delimit)
call pdup			# (P dest0 dest')  ( delim )
call step
call drop

while_this_isnt_delim:
	call this		# (P dest0 dest')  (delim this)
	call step		# (P dest0 dest')  (delim this EOI)
	YES( 		spfoo)
	call over
	call over		# (P dest0 dest')  (delim this del ths)
	call maskbyte			
 	call ifequal		# (P dest0 dest')  (delim this =)
		YES( 	tchneetz)
	call store		# (P dest0 dest')  (delim )
	call pplusb		# (P dest0 dest++) (delim )
ELL(		while_this_isnt_delim)
spfoo:
		call drop
		call drop
		call gap
		call Negate
		call pdrop
		call false
			Return
tchneetz:
			call drop
			call drop
			call gap
			call Negate
			call pdrop
			call true
				Return
			

   # ttttttttttttttttttttttt============

#   drowod		(P HNC --- ???) (???)  (R ?????) !USize	 Interpreter only
NON_USER(drowod,drowod)

call USize
call pfetch
call bump
call pTOs
call drop
call doHNC		#U (P ???) (???) (R???)
 # we may have changed Size, so we save it for the next time we reenter
 # user context.
call sTOp		#  (P ??? USize) (???) (R???)
call USize		#  (P ??? USize &USize) (???) (R???)
call pstore		#  (P ??? USize &USize) (???) (R???)
call twopdrop		#  (P ???) (???) (R???)
call cells		   #	4 !Size
	Return


   # ttttttttttttttttttttttt============

#   ell		assemble/append an unconditional branch

THREADING(Ell,ell)
call sTOr
call bytes
call literal
.byte 1
.byte 0xeb
call append
call rTOs
	Return


   # ttttttttttttttttttttttt============

#   finish		( --- EOI) !toklen !tb !this	get rest of token
THREAD_(finish,finish)
				# we come in on a nonwhite from snug
call tb				# (P tokenbuffer)
call this			#  (P tb)	( this )
call store			#  (P tb) <-- ()
call pplusb			#  (P tokenbuf_next) ()
call one				#  (P tokenbuf_next) (initial_toklen=1)
while_nonwhite:

	call step		# this++ (P tb) (toklen EOI)
	NO(		abkloo)
	call drop		# ran out of input
	call pdrop
	call true		# ( EOI=true )
		Return
abkloo:	
	call thispointer		#  (P tb' &this ) ( toklen )
	call pfetch		#  (P tb' this )  ( toklen )
	call ifchar		#  (P tb' )	(toklen	 ischar)
				# ifchar does a pdrop. Doh! BAD!
	NO(		finito)
	call one			# (P tb)   ( toklen 1 )
	call plus		# (P tb)   ( toklen'  )
	call this		#  (P tb )  (toklen' this )
	call store		#  (P !tb )  <--  (toklen' )
	call pplusb		#  (P tokenbuf_next)	(toklen' )
ELL(		while_nonwhite)
finito:
		call toklen	# (P tb' toklen)     (toklen)
		call store	# (P tb' !toklen) <--/
		call twopdrop	# (P tb' !toklen)
		call false	# ( EOI=false)
			Return


   # ttttttttttttttttttttttt============

#   <-code		`fromcode' (P CFA --- HNC )  ( --- found_flag )
 #				`see' needs this.
THREAD_(fromcode,<-code)
call pminusc				# (P lfa_of_sought)
call Latest				# (P sought &HNC)
call pfetch				# (P sought HNC)
call pdup
call pTOr				# (P sought HNC) (R HNC)
call TOlink				# (P sought lfa) (R HNC)
fromcfa:	
	call rdrop			# (P sought lfa) (R)
	call pfetch			# (P sought HNCp) (R)
	call fetch
	NO(	   kje)			# AARDVARK!
	call pdup	
	call pTOr			# (P sought HNC) (R HNC)
	call TOlink			# (P sought lfa) (R HNC)
	call gap				# (P sought lfa) (R HNC) ( same?)
	call flag
YES(	       fromcfa) 		# yes, different. try again.
call true				# found
call twopdrop				# (P)	 (R HNC)
call rTOp				# (P HNC)	(R)
	Return
kje:
call false				# no word found with that "CFA"
call twopdrop				# (P)	 (R HNC)
call rTOp				# (P HNC)	(R)
	Return


   # ttttttttttttttttttttttt============

#   H3m		no-op thread, simplifies commandline handling
THREAD_(H3m,H3m)
Return


   # tttttttttttttttttttttttttttttttttttttttt============

#   hexnumber	( --- # )  from current token
THREAD_(hexnumber,hexnumber)
call toklen			#			(P &toklen)
call fetch			# ( len )		(P )
call pdrop
call tb				# ( len )		(P tb )
call zero			# ( len  accum0)	(P bt)
while_hexchar:
	call over		# ( len accum len)	(P char)
	NO(		hemde)
	call literal		# ( len  accum)	(P char)
	BYTE(4)			# ( len  accum)	(P char)
	CELL(4)			# ( len  accum	 4)	(P char)
	call ushift		# ( len  accum<4)	(P char)
	call asciiTOdigit	# ( len  accum< dig)	(P char)
	call Or			# ( len  accum<+)	(P char)
	call swap		# ( accum  cnt)	(P char)
	call onbits		# ( accum  cnt -1)	(P  char)
	call plus		# ( accum  cntd)	(P  char)
	call swap		# ( cntdn  accum)	(P  char)
	call pplusb		# ( cntdn  accum)	(P char')
ELL(		while_hexchar)
hemde:
				# ( len accum)		(P char)
		call pdrop	# ( len accum)		(P )
		call swap	# ( accu  len)		(P )
		call drop	# ( accu)		(P )
			Return


   # tttttttttttttttttttttttt============

#   hide 		(P &HNC ||| )  ( toggle hide bit )
THREAD_(hide,hide)
call sTOr
call cells
call fetch
call literal
 BYTE(4)
 CELL(0x1000000)
call Xor
call store
call rTOs
	Return


   # tttttttttttttttttttttttt============

#   ifabbreviation	(P --- HNC|NULL)  ( --- flag ) "'abbreviation toke. "
NON_USER(ifabbreviation,ifabbreviation)
call tb			#   (P &bt)
call sTOr		#   (P bt )			(R Size
call bytes		# Size = 1	!!!bytes
call toklen		#   (P bt toklen)			(R oS
call fetch		#   (P bt toklen)	( len)		(R oS
call pdrop		#   (P bt )		( len)		(R oS
call pdup		#   (P bt bt)	( len)		(R oS)
call one
call minus
call dup			#   (P bt )	( len-1 len)	(R oS)
call plusp		#   (P bt et)	( len-1)	(R oS)
call fetch		#   (P bt et)	( len lastchar) (R oS)
call literal		#   (P bt et)	( len lastchar) (R oS)
  BYTE(4)
  CELL(46)		#   (P bt et)	( len lastchar .) (R oS)
call ifequal	       #   (P bt et)  ( len flag)	(R oS)
YES(		gheef)
call drop	       # NOT AN ABBREVIATION, exuent
call false		#   (P bt et)	(false)		(R oS)
call twopdrop
call rTOs
	Return		# (false)
gheef:
		       # TOKEN IS AN ABBREVIATION	(R oS)
call pdrop		#   (P bt )	(len-1)		(R oS)
call Latest
call pfetch		#   (P bt latest ) (len )  (R oS)
			# seed ds ?hit and rs ?HNC
call false
call swap		#   (P bt latest ) (?hit  len) (R oS)
call pdup
call pTOr		#   (P bt latest ) (?hit  len) (R ?HNC oS)
ifabbr:
	call fetch	#   (P bt latest ) (hit? toklen  namebyte )
YES(		nlie)	# yes. more dictionary to do.
			# no. aardvark. Finish up.
call twopdrop		#   (P )		(hit? toklen)
call drop		#   (P )		(hit? )
call dup			#   (P )		(hit? hit?)
NO(		hdtnlie)
			# was a word
call rTOp		#   (P &HNC)		(true)
call rTOs		#	(P &HNC)	(true)
	Return
hdtnlie:
			# wasn't a word
call rdrop		#   (P) = NULL		(false)
call rTOs
	Return
nlie:	
			#   (P bt  last ) (hit? len )
			# substring comparison, hop over to name
call pplusc		#   (P bt name ) (hit? len )
			#  {{{(P beg.	beg. ||| --- ) ( len ||| --- flag}}}
   call ifsegmentsequal	#   (P bt  name ) (hit? len  flag )
	NO(	xiern)	# nope.
			# yup. this is one possible completion
call pminusc		#   (P bt  &HNC_hit )	(hit? len)
call rdrop		# overwrite rs?HNC
call pdup
call pTOr		#    "	     "
			# overwrite ?hit with true
call swap		# (P bt &HNC_hit )	(len ?hit)
call drop		# (P bt &HNC_hit )	(len)
call true		# (P bt &HNC_hit )	(len true)
call swap		# (P bt &HNC_hit )	(true len)
call TOlink		# (P bt LFA  )		(true len)
call pfetch		# (P bt HNC' )		(true len)
ELL(		ifabbr)
xiern:
	call pminusc
	call TOlink		# (P bt LFA  ) (?hit len )
	call pfetch		# (P bt HNC' ) (?hit len )
ELL( 		ifabbr)


   # ttttttttttttttttttttttt ===========

#   ifhex		( --- flag ) (P char ||| )
NON_USER(ifhex,ifhex)
call fetch		       #   (...   char	    (P... char |||
call maskbyte		       #   (...  charbyte  (P... char |||
				#	CHARSIZE ASSUMPTION
call hexdigits			#   (...  charbyte  (P... char ||| array
call plusp			#   (...	     (P... char ||| index
call fetch			#   (... flag	     (P... char ||| index
call pdrop
call maskbyte
	Return


   # ttttttttttttttttttttttt============

#   include 	"incl. relative_pathname "
THREAD_(include,include)
call zero
call zero
call open
call input
	Return


   # ttttttttttttttttttttttt============

#   input		( FD --- ) interpret input on FD til exhausted
THREAD_(input,input)
call Source
call store
call pdrop
call refill			# (--was_some) @source !this !buffer !epa */ 
	NO(	exuentinput)
while_input:
	  call token			# (EOI)
		YES(	exuentinput)
	  call interpret			#   user context  ????????
ELL(			while_input)
exuentinput:
		call zero
		call Source
		call store
		call pdrop
		call refill
		call drop
		       Return


   # ttttttttttttttttttttttt==========

#   interpret	interpret one token. Unknown stack effects. EVAL basically.
THREAD_(interpret,interpret)

call ifword				# (P HNC/NULL ) ( flag)	
NO(		wasntword)
call drowod
				# user context ??????????????????
	Return
wasntword:
call ifabbreviation			# (P HNC/NULL ) ( flag)
NO(			thaoefu)
call drowod				# user context ????????????????
	Return
thaoefu:
call ifhexnumber
NO(			tryfilespace)
call rebmunxeh
		Return

tryfilespace:
call dofile	
NO(				interbonk)
	Return


interbonk:
	call cr
	call tb
	call toklen
	call fetch
	call pdrop
	call printstring
	call beep
	call pdrop
		Return


   # ttttttttttttttttttttttt============

#   initresolve	init branch resolver stacks
NON_USER(initresolve,initresolve)
call branchstack			# (P &bs)
call bsi				# (P &bs &bsi)
call pstore			# (P &bs &bsi)
call twopdrop
call targetstack			# (P &bs)
call tsi				# (P &bs &bsi)
call pstore			# (P &bs &bsi)
call twopdrop
	Return


   # ttttttttttttttttttttttt============

#   lf		emit an ASCII linefeed, unix "newline"
THREAD_(lf,lf)
call literal 
 BYTE(4) 
 CELL(10) 
call emit 
	Return


   # ttttttttttttttttttttttt============

#   link		!dp   !latest	  link a word to the dictionary
THREAD_(link,link)
call Latest		#	(P  &latest)
call pfetch		#	(P  latest)
call appendp		#	(P  latest)   !dp !HERE
call pdrop		#	(P)
call pvar
call pfetch
call Latest
call pstore
call twopdrop
	Return


   # ttttttttttttttttttttttt============

#   name		"name newname "	   part of :
THREAD_(header,name)
			# ENDIANISM THANG
call sTOr
call dp
call pfetch
call pvar
call pstore		# link uses the value in pvar. Fugly.
call twopdrop
call token		# (flag)
call drop		# ()
call bytes
call toklen		#		(P  &toklen)
call fetch		#		(P  &toklen)  ( toklen )
call append		#		(P  &toklen)
call pdrop		#		(P )
call zero		# (0)
call append		# ()
call literal
 BYTE(4)
 CELL(0)		# (0)		non-atomic
call append		# ()
call zero		# (0)
call append		# ()
call rTOs
call tb			# ()		(P tb )
call toklen		# ()		(P tb	&toklen)
call fetch		# (len)	(P itb	&toklen)
call pdrop
call dup			# (len len)	(P itoken)
call dp			# (len len)	(P itoken &dp)
call pfetch		# (len len)	(P itoken dp)
call move		# (len)	(P itoken dp)
call plusp		# ()		(P itoken dp')
call dp			# ()		(P itoken dp' &dp)
call pstore		# ()		(P itoken dp' &dp)
call pdrop
call align		# ()		(P itoken dp_al)
call dp
call pstore
call twopdrop
call twopdrop			SUSPECT
	Return


   # ttttttttttttttttttttttt============

#   negate		( bla --- 2's-complement-negative-bla)
THREAD_(Negate,negate)
call Not
call one
call plus
	Return


   # ttttttttttttttttttttttt============

#   no		assemble/append a branch-on-false conditional
THREADING(No,no) 
	# append literals constituting the code in the NO macro
call sTOr
call cells
call literal
.byte 4
.int  0xd329038b
call append
call literal
.byte 4
.int 0x0000ff25
call append
call bytes
call literal
.byte 1
.byte 0x00
call append
call literal
.byte 1
.byte 0x74
call append
call rTOs
call true
	Return


   # ttttttttttttttttttttttt============

#   now		"now bla " do bla now, don't thread it
THREADING(now,now) 
call token
call interpret
call true
	Return



   # ttttttttttttttttttttttt============

#   open		( flags perms --- FD|err)  "open  filename " @!tb
THREAD_(open,open)
call TO_C		# (P tb )	(flags perms)
call open_		# (P tb )	(FD)
call pdrop		# (P)		(FD)
	Return


   # tttttttttttttttttttttt============

#   pad		(P  --- dp+255)
THREAD_(pad,pad)
	call dp
	call pfetch
	call onbits
	call maskbyte
	call plusp
		Return


   # ttttttttttttttttttttttt============

#   ( 		"(  whatever      ) "  comment. Use # in defs
THREAD_(paren,``('')
call literal
 BYTE(4)
 CELL(0x29)
while_spam:
	call dup
	call this
	call step
	YES(			parenthlu)
	call maskbyte
	call ifequal
	YES(			parenthlu)
	ELL(					while_spam)
parenthlu:
call true
	Return


   # ttttttttttttttttttttttt============

#   \ 		"#  whatever  nl"  one-line comment. works in : ;
THREADING_NAMELEN(backslash, \\\\ ,1)

call literal
 BYTE(4)
 CELL(10)
__line:
	call dup
	call this
	call step
	YES(		flafnan)
	call maskbyte
	call ifequal
	YES(		flafnan)
	ELL(				__line)
flafnan:
call true
	Return


   # ttttttttttttttttttttttt============

#   postpone 	"postpone bla " child will append CFA (and sub) of bla
THREADING(postpone,postpone)
call tick		# (P HNCbla|null )	(flag)
call drop		# assume word
call TOcode
call pliteral
CELL(pliteralCFA)           # (P CFAbla CFAplit )
call appendp
call pdrop               # (P CFAbla)
call appendp
call pdrop               # (P)
call pliteral
.byte 0xe8, 90, 90, 90				# note endianism
			# (P CFAsub)
call appendp
call pdrop               # (P)
call pliteral
CELL(appendpCFA)	# (P CFA&p )
call appendp
call pdrop               # (P)
call pliteral
CELL(pdropCFA)               # (P CFApdrop )
call appendp
call pdrop               # (P)
call true
	Return


   # ttttttttttttttttttttttt===========

#   p2dup		(P a b ||| --- a b ) dup 2 pointers in-phase
THREAD_(p2dup,p2dup)
call pover
call pover
	Return


   # ttttttttttttttttttttttt============

#   p2+s		(P  ptr	 ptr  --- ptr+s	 ptr+s )
THREAD_(p2pluss,p2+s)
call ppluss
call pdrop
call ppluss
call pup
	Return

#		see x for Forth "." until H3sm gets BASE



   # ttttttttttttttttttttttt============

#   .history
NON_USER(printhistory,.history)
call historyFD
call fetch			 #  FD#
call pdrop

call toklen
call fetch
call pdrop			# len
call one
call plus

call dup
call tb
call historybuffer		# buffer
call move
call write
call twopdrop
call drop
	Return



   # ttttttttttttttttttttttt============

#   .p		print pointer  non-destructively
THREAD_(printp,.p)
call pdup
call pTO		#  ( --- p ) 4 bytes moved regardless
call printhex	#  ( --- )
	Return


   # ttttttttttttttttttttttt============

#   .r		print TOR nondestructively
THREAD_(printr,.r)
call rpcopy
call printp
	Return


   # ttttttttttttttttttttttt===========

#   .string		(P begin  ||| ) ( length --- ) print a string
THREAD_(printstring,.string)
call pdup
call TOr
prints:
	call fetch
	call emit
	call minusaskr
	call pplusb
	YES(			prints)
call pdrop
call rdrop
	Return


   # ttttttttttttttttttttttt============

#   .$ 		(P $+c ||| )    print a $egment
THREAD_(printshegment,.$)

call literal
 BYTE(4)
 CELL(1)		# VECTOR THIS			1	 

call pdup			#   $+c $+c		1
call pminusc			#   $+c $
call pfetch			#   $+c count		1	
call pTO				#   $+c			1 count
call write			#   $+c			wrote
call pdrop
 # call drop
	Return


   # ttttttttttttttttttttttt============

#   .chars		(P begin  ||| ) ( length --- ) prt 126 > chars > 32
THREAD_(printchars,.chars)
call TOr
call pdup			# (P str) (R len )
lprintchars:
	call fetch		# ( c )
	call literal
	 BYTE(4)
	 CELL(32)		# ( c blank)
	call max			# ( c|blank)
	call literal
	 BYTE(4)
	 CELL(126)		# ( c|blank  ~)
	call min			# ( c|blank|~)
	call emit		# ()
	call minusaskr		# ( flag )		(R n-1)
	call pplusb		#  ( flag ) (P str')	(R n-1)
	YES(	lprintchars)
call rdrop			#  () (P str')
call pdrop
	Return


   # |||||||||||||||||||||||||||||||||============

#   .name		(P   &HNC ||| )	print a word's H3m name
THREAD_(printname,.name)
call pdup
call fetch
call maskbyte
call literal
 BYTE(4)
 CELL(4)
call plusp
call onbits
call plus
call printstring
call pdrop
call blank
	Return


   # ttttttttttttttttttttttt============

#   resolve_one	resolve one branch in thread being threaded
NON_USER(resolve_one,resolve_one)
call bsi			# (P  &bsi)
call pfetch		# (P  bsi )
call pminusc		# (P  bsi-)
call pdup		# (P  bsi-  bsi-)
call pfetch		# (P  bsi-  targ.stck.addy)	pop
call pfetch		# (P  bsi-  targ.addy)
call pswap		# (P  targ.addy bsi-)
call pminusc		# (P  targ.addy bsi--)
call pdup		# (P  targ.addy bsi-- bsi--)
call pfetch		# (P  targ.addy bsi-- poke.loc )
call pswap		# (P targ.addy poke.loc bsi--)
call pTOr		# (P targ.addy poke.loc bsi--) (R bsi--)


call sTOr
call bytes


call gap
call one
call minus
call store		#  (P targ.addy poke.loc) (R bsi--) RESOLVED!
call rTOs

call twopdrop		# (P ) (R bsi--)
call rTOp		# (P bsi--)
call bsi			# (P bsi-- &bsi)
call pstore
call twopdrop
	Return



   # ttttttttttttttttttttttt============

#   refill		( --- got ) @source !this !epa !buffer   more input
THREAD_(refill,refill)
call Source		# (p &source)
call fetch		# (P)			(fd)
call pdrop
call buffer		# (P buffer)		(fd)
call read		# (P buffer)		( got)
call dup			# (P buffer)		( got got)
call thispointer		# (P buffer tp)	( got got)
call pstore		# (P buffer->tp)	( got got )
call pdrop		# (P buffer)		( got got )
call plusp		# (P buffer+)		( got )
call epa			# (P buffer+ &epa)	( got )
call pstore		# (P buffer+->&epa)	( got )
call twopdrop		# (P)			( got )
	Return

   # ttttttttttttttttttttttt============

#   resolve		(--- true) @bs @ts, thread all pending branches THREADer
 #			resolve uses bs decr.-pop style
THREADING(resolve,resolve)
lresolve:
	call branchstack
	call bsi				# (P  &bs &bsi)
	call pfetch			# (P  &bs bsi )
	call gap				# (P  &bs bsi )  (gap)
	call twopdrop			# (gap)
	NO(		resovo)		# no branches pending
					# resolve a pending branch
	call resolve_one			# ()
ELL(			lresolve)
resovo:	
		Return


   # tttttttttttttttttttttttttttttttttttttttt============

#   rebmunxeh	(  --- #_in_user_data_stack_context ) The Dreaded Rebmunxeh.
NON_USER(rebmunxeh,rebmunxeh)
call USize
call pfetch
call bump
call pTOs
call drop
call toklen
call fetch			#   (len)
call pdrop
call tb				#	(len)		(P tb)
call zero			#   ( len  accum0	(P  bt
rebmunx:
	call over		#   ( len accum len	(P char
	NO(		ghok)
	call literal		#   ( len  accum  4	(P char
	BYTE(4)			#   ( len  accum<	(P char
	CELL(4)
	call ushift
	call asciiTOdigit	#  ( len  accum< dig	(P char
	call Or			#  ( len  accum<+	(P char
	call swap		#  ( accum  cnt	(P char
	call onbits		#  ( accum  cnt   -1	(P char
	call plus		#  ( accum  cntdn
	call swap		#  ( cntdn  accum
	call pplusb		#  ( cntdn  accum	(P char'
ELL(			rebmunx)
ghok:				#  ( len accum (P char
		call pdrop	#  ( len accum
		call swap	#  ( accu  len
		call drop	#  ( accu ) leave this in user context

		call cells
			Return


   # ttttttttttttttttttttttt============

#   ;		( --- stop_THREADer) set a target, resolve, & a return.
THREADING(semicolon,;)
call target		# (P &dp)
call drop		# (P dp)
			# resolve branches
call resolve
call sTOr
call bytes
call literal		# THREAD  a return
.byte 1, 0xc3 
call append		 # (P )
call bump
call rTOs
call drop


call pdrop		SUSPECT
call false		# tell : to stop threading
	Return


   # ttttttttttttttttttttttt============

#   space-terminate	() 		GREMLINS
THREAD_(st,st)
call historybuffer			# (P tb )
call toklen				# (P tb tl)
call fetch				# (P tb tl)	(toklen)
call pdrop				# (P tb )	(toklen)
call plusp				# (P tb+tl)	()
call sTOr
call bytes
	call literal			# (P tb+tl)	( 0 )#
	.byte 4
	.int  32
	call store			# (P tb+tl)<--/
	call pdrop			# (P )
call rTOs
	Return


   # ttttttttttttttttttttttt============

#   spaces		( N --- )  emit N spaces
THREAD_(spaces,spaces)
call TOr
spacesloop:
	call blank
	call minusaskr
YES(		spacesloop)
	call rdrop
		Return


    # ttttttttttttttttttttttt ============

#   step		( --- EOI) true if End Of Input on this
THREAD_(step,step)
call thispointer
call pdup			# increment *thispointer
call pfetch
call pplusb
call pswap
call pstore
call twopdrop
call ifpending			# is there more buffer?
YES(		steppinout)

call refill			# refill checks for more input
call flag
call aint
	Return
steppinout:
	call false
		Return


   # ttttttttttttttttttttttt============

#   snug		( --- EOI) eat whitespace. snug+finish=token. Buffered.
THREAD_(snug,snug)
while_white:
	call thispointer			#  (P str )
	call pfetch
	call ifchar			#  ( --- ischar) does a pdrop
	NO(			snugok)
		call false
			Return
snugok:
	call step			# ( --- EOI )	
	NO(			snugox)
	call true			##############  SUSPECT
		Return
snugox:
ELL(				while_white)

###### pointer spam?



   # tttttttttttttttttttttttttttttttttttttttttttttttttttt============

#   this		( --- current_input_buffer_byte ) interpreter part.
THREAD_(this,this)
call thispointer
call pfetch
call fetch
call pdrop
	Return


   # tttttttttttttttttttttttttttttttttttttttt============

#   threader	(P HNC |||) toggle word's THREDING bit. IMMEDIATE analogue
THREAD_(threader,threader)
call sTOr
call cells
call fetch
call literal
 BYTE(4)
 CELL(0x100)
call Xor
call store
call rTOs
	Return


   # tttttttttttttttttttttttttttttttttttttttt============

#   token		( --- End_Of_Input ) ?!tb !this
THREAD_(token,token)
call snug
YES(		tatatoken)
call finish
call drop
call false
       Return
tatatoken:
	call true
		Return


   # ttttttttttttttttttttttt============

#   to:		( --- keep_THREADer) set branch to resolve to start of word
 #				stack and make dict. room for br.
THREADING(tocolon,``to:'')
call dp			# (P &dp)
call pfetch		# (P dp)
call bsi			# (P dp  &bsi)
call pfetch		# (P dp   bsi)
call pstore		# (P dp   bsi)		!branchstackcell
call pplusc		# (P dp   bsi')
call targetstack		# (P dp   bsi' &ts0)	target spec 0
call pswap		# (P dp   &ts0 bsi')
call pstore		# (P dp   &ts0 bsi')	!branchstackcell
call pswap		# (P dp   bsi' &ts0)
call pdrop		# (P dp   bsi')
call pplusc		# (P dp   bsi'')
call bsi   		# (P dp   bsi'' &bsi)
call pstore		# (P dp   bsi'' &bsi)	 double-incr index
call twopdrop		# (P dp )
call pplusb		# (P dp')
call dp			# (P dp' &dp)
call pstore		# (P dp' &dp)		dp+c
call twopdrop		# (P )
call true		# (true)	say "keep going"
	Return


  # ttttttttttttttttttttttt============

#   to1		( --- keep_THREADing) set branch to first (O) to resolve
 #				stack and make dict. room for br.
THREADING(to1,to1)
call dp			# (P &dp)
call pfetch		# (P dp)
call bsi			# (P dp  &bsi)
call pfetch		# (P dp   bsi)
call pstore		# (P dp   bsi)		!branchstackcell
call pplusc		# (P dp   bsi')
call targetstack		# (P dp   bsi' &ts0)
call pplusc		# (P dp   bsi' &ts1)	target spec 1
call pswap		# (P dp   &ts1 bsi')
call pstore		# (P dp   &ts1 bsi')	!branchstackcell
call pswap		# (P dp   bsi' &ts1)
call pdrop		# (P dp   bsi')
call pplusc		# (P dp   bsi'')
call bsi   		# (P dp   bsi'' &bsi)
call pstore		# (P dp   bsi'' &bsi)	 double-incr index
call twopdrop		# (P dp )
call pplusb		# (P dp')
call dp			# (P dp' &dp)
call pstore		# (P dp' &dp)		dp+c
call twopdrop		# (P )
call true		# (true)	keep threading
	Return


  # ttttttttttttttttttttttt============

#   to2		( --- keep_THReding) set branch to second (O) to resolve
 #				stack and make dict. room for br.
THREADING(to2,to2)
call dp			# (P &dp)
call pfetch		# (P dp)
call bsi			# (P dp  &bsi)
call pfetch		# (P dp   bsi)
call pstore		# (P dp   bsi)		!branchstackcell
call pplusc		# (P dp   bsi')
call targetstack		# (P dp   bsi' &ts0)
call pplusc
call pplusc		# (P dp   bsi' &ts2)	target spec 2
call pswap		# (P dp   &ts2 bsi')
call pstore		# (P dp   &ts2 bsi')	!branchstackcell
call pswap		# (P dp   bsi' &ts2)
call pdrop		# (P dp   bsi')
call pplusc		# (P dp   bsi'')
call bsi			# (P dp   bsi'' &bsi)
call pstore		# (P dp   bsi'' &bsi)	 double-incr index
call twopdrop		# (P dp )
call pplusb		# (P dp')
call dp			# (P dp' &dp)
call pstore		# (P dp' &dp)		dp+c
call twopdrop		# (P )
call true		# (true)	keep threading
	Return


#   to3		( --- keep_THREDING) as above, reserve a cell
 #				stack and make dict. room for br.
NON_USER(to3,to3)
call dp			# (P &dp)
call pfetch		# (P dp)
call bsi			# (P dp  &bsi)
call pfetch		# (P dp   bsi)
call pstore		# (P dp   bsi)		!branchstackcell
call pplusc		# (P dp   bsi')
call targetstack		# (P dp   bsi' &ts0)
call pplusc
call pplusc
call pplusc		# (P dp   bsi' &ts3)	target spec 3
call pswap		# (P dp   &ts0 bsi')
call pstore		# (P dp   &ts0 bsi')	!branchstackcell
call pswap		# (P dp   bsi' &ts0)
call pdrop		# (P dp   bsi')
call pplusc		# (P dp   bsi'')
call bsi   		# (P dp   bsi'' &bsi)
call pstore		# (P dp   bsi'' &bsi)	 double-incr index
call twopdrop		# (P dp )
call pplusb		# (P dp')
call dp			# (P dp' &dp)
call pstore		# (P dp' &dp)		dp+c
call twopdrop		# (P )
call true		# (true)	keep threading
	Return


#   to4		( --- keep_THREDING) as above. Max (O) + 1 is at ;
 #				stack and make dict. room for br.
THREADING(to4,to4)
call dp			# (P &dp)
call pfetch		# (P dp)
call bsi			# (P dp  &bsi)
call pfetch		# (P dp   bsi)
call pstore		# (P dp   bsi)		!branchstackcell
call pplusc		# (P dp   bsi')
call targetstack		# (P dp   bsi' &ts0)
call pplusc
call pplusc
call pplusc
call pplusc		# (P dp   bsi' &ts0)	target spec 4
call pswap		# (P dp   &ts0 bsi')
call pstore		# (P dp   &ts0 bsi')	!branchstackcell
call pswap		# (P dp   bsi' &ts0)
call pdrop		# (P dp   bsi')
call pplusc		# (P dp   bsi'')
call bsi			# (P dp   bsi'' &bsi)
call pstore		# (P dp   bsi'' &bsi)	 double-incr index
call twopdrop		# (P dp )
call pplusb		# (P dp')
call dp			# (P dp' &dp)
call pstore		# (P dp' &dp)		dp+c
call twopdrop		# (P )
call true		# (true)	keep threading
	Return


#   to5		( --- keep_THREDING) as above. Max (O) + 1 is at ;
 #				stack and make dict. room for br.
THREADING(to5,to5)
call dp			# (P &dp)
call pfetch		# (P dp)
call bsi			# (P dp  &bsi)
call pfetch		# (P dp   bsi)
call pstore		# (P dp   bsi)		!branchstackcell
call pplusc		# (P dp   bsi')
call targetstack		# (P dp   bsi' &ts0)
call pplusc
call pplusc
call pplusc
call pplusc
call pplusc		# (P dp   bsi' &ts0)	target spec 4
call pswap		# (P dp   &ts0 bsi')
call pstore		# (P dp   &ts0 bsi')	!branchstackcell
call pswap		# (P dp   bsi' &ts0)
call pdrop		# (P dp   bsi')
call pplusc		# (P dp   bsi'')
call bsi			# (P dp   bsi'' &bsi)
call pstore		# (P dp   bsi'' &bsi)	 double-incr index
call twopdrop		# (P dp )
call pplusb		# (P dp')
call dp			# (P dp' &dp)
call pstore		# (P dp' &dp)		dp+c
call twopdrop		# (P )
call true		# (true)	keep threading
	Return


   # ttttttttttttttttttttttt============

#   tab		emit a tab, ASCII 9
THREAD_(tab,tab)
call literal
 BYTE(4)
 CELL(9)
call emit
	Return


   # ttttttttttttttttttttttt============

#   (O)		`target' ( --- keep_THREaDING) set a branch target 
THREADING(target,(O))
call dp				# (P &dp)
call pfetch			# (P dp)
call tsi				# (P dp &tsi)
call pfetch			# (P dp tsi)
call pstore			# (P dp tsi)	    target stashed
call pplusc			# (P dp tsi')
call tsi				# (P dp tsi' &tsi)
call pstore			# (P dp tsi' &tsi)  ts index incr'd
call pdrop			# (P dp tsi')
call twopdrop
call true			# (true)   keep threading
	Return


   # ttttttttttttttttttttttt============

#   threadtoken	( --- keep_going? )  called after "token"
NON_USER(threadtoken,threadtoken)
call ifword
NO(			notplainwoid)
	call ifthreader
	YES(					dothreader)
		call appendword
		call true
		call pdrop
			Return
notplainwoid:
call ifabbreviation
NO(			notevenwerd)
call ifthreader	
YES(						dothreader)
	call appendword
	call pdrop
	call true
		Return
notevenwerd:
 	call ifhexnumber
	NO(				yeahright)	   
 		call hexnumber
 		call appendlit
		call true
			Return
yeahright:
call iffile
	NO(			yerwhathertz)
		call H3m	#stub
		call true
			Return	
yerwhathertz:
	call beep
	call toklen
	call fetch
	call pdrop
	call tb 
	call cr
	call tab
	call printstring
	call cr
	call pdrop
		Return
dothreader:
call doHNC
	Return


   # ttttttttttttttttttttttt============

#   threadloop	called by : . Build the body of a thread. Stops after ;.	
NON_USER(threadloop,threadloop)
threadtokens:
	call token
	YES(		threadloopdone)		# EOI was true. ciao.
		call threadtoken
		NO(		threadloopdone)	# if keep-going is false
ELL(				threadtokens)

threadloopdone:
			Return


   # TTTTTTTTTTTTTTTTTTTTTTTT============

#   '		`tick'
THREAD_(tick,`'')
call token
YES(					tickout)
	call ifword
	NO(				dyanchel)
		call true
			Return
dyanchel:
call ifabbreviation
NO(		tickout)
	call true
		Return
tickout:
	call false
		Return


   # tttttttttttttttttttttttt============

#   '&		"'& word "  HNCword -> dictionary   !dp	THREDING
THREADING(ticappend, `''&)
			# put HNC of "word" in thread
call tick
call appendp
call pdrop
call true		# tell threader "keep going"
	Return


   # tttttttttttttttttttttttt============

#   '&code		"'&code  word " CFAword->dictionary !dp	 THREDING
THREADING(ticappendcode, `''&code)
			# put CFA  of "word" in thread
call tick
call TOcode
call appendp
call pdrop
call true		# tell threader "keep going"
	Return


   # ttttttttttttttttttttttt============

#   'p&		"'p& word " thread does ->  (P --- HNCword ) !dp THREDING
THREADING(ticpappend, `''p&)
call pliteral		# put pliteral xt in thread
.int pliteralCFA	
call appendp
call pdrop
			# put HNC of "word" in thread
call ticappend
	Return


   # ttttttttttttttttttttttt============

#   ->C		(P --- tb ) "->C string " 0-terminate a token
THREAD_(TO_C,``->C'')
  call token		# (got_one) 
call drop		# ()
SUSPECT

call zeroterminate	# ()
call tb			# (P tb)
	Return


   # ttttttttttttttttttttttt============

#   wait		
THREAD_(wait,wait)
call zero
call zero
call waitpid
	Return


   # ttttttttttttttttttttttt============

#   words		( cnt --- ) print cnt wordnames from latest
THREAD_(words,words)
		# put downcounter on rs and enter dictionary
		# have to size up to cells for un-used bit check
call sTOr
call cells
call Latest			# (P &latest ) (count)
call pfetch			# (P latest )	 (count)
call TOr				# (P latest )	 (R;  count )
nwords:
	call fetch		# (P &HNC')	(R;  count ) (*HNC)
	NO(		fwodle)	# aardvark
	call fetch		# (P &HNC')   (R;  count ) (*HNC)
	call literal
	 BYTE(4)
	 CELL(0x01000000)
	call And			# (P &HNC')   (R;  count ) (userflag)
	call flag		# (P &HNC')   (R;  count ) (userflag)
	call aint
		NO(	dlieth)	#  NON-USER thread
				# regular word
	   call printname
	  call blank	
dlieth:
		call TOlink
		call pfetch	# (P &HNC')	(R;  count )
		call minusaskr	# (P &HNC')   (R;  count' )	(flag)
YES(			nwords)	#  not done with count
fwodle:
call rdrop			# count is 0, ciao
call pdrop
call rTOs
call cr
	Return


   # ttttttttttttttttttttttt============

#   yes		assemble/append a branch-on-true conditional
THREADING(Yes,yes) 
	# append literals constituting the code in the YES macro
call sTOr
call cells
call literal
.byte 4
.int  0xd329038b
call append
call literal
.byte 4
.int 0x0000ff25
call append
call bytes
call literal
.byte 1
.byte 0x00
call append
call literal
.byte 1
.byte 0x75
call append
call rTOs
call true
	Return




   # ttttttttttttttttttttttt============

#   0-terminate	() 	C-ify a token in tb.  !tb
THREAD_(zeroterminate,0-terminate)
call tb					# (P tb )
call toklen				# (P tb tl)
call fetch				# (P tb tl)	(toklen)
call pdrop				# (P tb )	(toklen)
call plusp				# (P tb+tl)	()
call sTOr
call bytes
	call zero			# (P tb+tl)	( 0 )
	call store			# (P tb+tl)<--/
	call pdrop			# (P )
call rTOs
	Return


   # ttttttttttttttttttttttt============

#   zygote		top endless loop, do argv[], do rcfile,  
  #				then loop over input

initial_LATEST:		# label at HNC for dist. init.

NON_USER(zygote,zygote)

#call pad 			# initialize unix argument stasher
#call arglast
#call pstore
#call twopdrop

#call literal			# open the H3story file
# BYTE(4)
# CELL(0)
#call literal
# BYTE(4)
# CELL(2)
#call historyname
#call open_
#call pdrop
#call historyFD			# stash H3story FD and dup for a seek
#call dup
#call store
#call pdrop
#
#call one			# lseek to EOF, 0 o/s, whence = end
#call one			# lseek to EOF, 0 o/s, whence = end
#call plus
#call literal
# BYTE(4)
# CELL(4)
#call seek 

			#include(tests)
#call literal
# BYTE(4)
# CELL(0)
#call literal
# BYTE(4)
# CELL(0)
#call rcfile
#call open_
#call dup
#call ifpositive
#NO(		top_loop_of_H3sm)
#	call input

	jmp mozygote

top_loop_of_H3sm:

#Chromelkia 
		call token
		YES(		mozygote)
		call interpret
ELL(							top_loop_of_H3sm)
	#zzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz


mozygote:
		call beep
		call Source
 	      	call zero
  	          call store
   	        call pdrop
	         call cr
                call refill
                call drop
ELL(			top_loop_of_H3sm)
initialdp:


#
#   glossary may include THREAD_ words "words" hides.
#   H3m is case-sensitive. Booleans OR, AND, XOR and NOT are uppercase.
#   H3m abbreviation/pronounciation  conventions ...
#   	?      @	!	->	.	&	'	$
#   	ask    fetch	store	to	print	append	tick	segment
#   & (append) is to Forth `comma' as assemble is to compile.
#   (is usually a copy, -> is usually a move or pop, source is dropped.
#   & in stack comments, e.g. @HNC, sometimes means "address of"
#   ||| means "stuff to the left is required but not changed".
#   ?* words like ?char etc. (and flag) produce flagpytes.
#   format		(optional fields, optional order
#   name		`pronounced'  stacks effects  "parsing syntax"  notes

 #
 #H3m 3-stack programming interface (virtual machine design) in GNU C, m4,
 #	and GNU "as" assembler for x86.
 #
 #199804 <--> 200003   Rick Hohensee
 #humbubba@smart.net	http://www.smart.net/~humbubba
 #
 #199812	 Michael Somos "http://grail.cba.csuohio.edu/~somos/"
 #	non-endianness, routine delimiter comment lines, etc.
 #
 #See also Ertl/Paysan GForth and GNU .info on gcc "labels as values",
 #the unix section 2 manpages, Linux man 2 intro in particular, and the
 #GNU .info on gas.
 #
 #The sourcecode of the "Arith" and "calc" arbitrary precision arithmetic
 #packages for unices were consulted for this implementation of pyte
 #arithmetic, although pytes are quite different from numbers in those
 #systems.
 #
 #Phil Koopman's book "Stack Computers; The New Wave" bears mention. It is
 #currently on the web at "http://www.cs.cmu.edu/~koopman/stack_computers/".
 #
 #Also worth mention are the generally meritocratic and cooperative tones of
 #comp.lang.forth, MdFIG and linux-kernel@vger.rutgers.edu. Greg Patterson
 #was helpful at a particularly frustrating moment with C pointers. Two
 #design features of H3m were suggested by JET Thomas; the single-whole-pass
 #dictionary search method used by abbreviations, and that pyte sizes go up
 #to 256 bytes instead of 128. Explanations by Elizabeth Rather and others
 #in c.l.f led to me eliminating H3m words that access the parameter stack
 #pointer directly, since a pure stack that has no concept of a "stack
 #pointer" is sufficient for a stack machine, and probably preferable.  I
 #had a copy of John Brien's "Build Your Own Forth" webpage in my
 #/usr/src/H3m . (original URL is
 #"http://www.users.zetnet.co.uk/aborigine/byof.htm")
 #
 #The printer Charles Lasitter of Durham, N.C. gave me has done yeoman
 #service as an essential debugging tool. As have the several PS/2's,
 #the Pentium, and the cash. I believe the technical term for the likes
 #of Chuck Lasitter is "angel".
 #
 #H3m has also recieved direct help from Richard B. Johnson, Brian Raiter,
 #and direct help or inspiration from various anonymous Internet Relay Chat
 #personages. The nom_de_IRC's _Anarchy_, tm2, shaver and * come to mind.
 #
 #As pertains copyrights and release thereof, H3m is not a derived work of
 #any prior work.
 #
 #This version of H3m is hereby released into the public domain. I am of
 #the understanding that "public domain" does not release users of H3m from
 #the obligation of properly associating my name with the work. Subsequent
 #work I do on H3m may be released under more restrictive terms.
 #"
 #DESIGN
 #
 #Each of the 3 "stacks" has a distinctly different related ops from the other
 #2.
 #
 #return
 #	The return stack will contain only xt's. An xt is what NEXT can use,
 #	an address space int-ply index to an atom, which is machine code.
 #
 #pointer
 #	The H3m pointer stack is cell-sized, but contains only actual host
 #	address-space pointers usually. Such an entity is called a "pointer"
 #	from the H3m-user point of view. The pointer stack may be a bridge
 #	between the H3m VM and the host, but only with specific fundamentals
 #	for host services, such as system calls. Internally, the pointer stack
 #	index is usually left pointing to an occupied cell.
 #data
 #	The data stack operates on "pytes", groups of 1 <--> 256
 #	bytes. Boolean flags are the low byte of a pyte. False is zero.
 #	Non-zero is true. The H3m   true   word asserts 255 in a flagpyte.
 #	The stack index itself is byte-ply, but pyte operations are at Size.
 #	The data stack pointer points at the top occupied cell. This is
 #	important to keep in mind when changing Size.
 #
 #	Size "Register"
 #
 #	The current effective size of data stack operands is the Size state
 #	variable. There are user-visible accessors of this Size "register".
 #	Operations on pytes are in terms of Size, except where a pyte is
 #	treated as a flag or character.
 #
 #So the 3 stacks are the data typing of H3m, in a sense. Typing is enforced
 #by the various operands. The data stack is where a datum can be treated
 #arbitrarily.
 #
 	# comments beginning in leftmost character column are
 #appended to the glossary file by the Glossary script.

  HEAP:
.org . +  0x2000


